 TITLE ARKANO1

;  PROGRAMA PRINCIPAL 

        EXTRN BLANCOS: FAR      ; INSTANCIAMOS COMO EXTERNAS LAS RUTINAS 
        EXTRN DIRPANT: FAR      ; QUE VAMOS A UTILIZAR.
        EXTRN MENSAJE: FAR
        EXTRN ESCR_CAR: FAR
        EXTRN PR: FAR            
        EXTRN PREJUE: FAR
        PUBLIC DIRPAN           ; DECLARAMOS PUBLICAS LAS VARIABLES QUE VAMOS
        PUBLIC JUGADOR          ; A UTILIZAR EN LAS SUBRUTINAS FAR COMO 
                                ; GLOBALES
        
   PILA SEGMENT PARA STACK 'PILA'       ; DECLACION DEL SEGMENTO DE PILA
        DB 64 DUP ('PILA....')
   PILA ENDS

   DATOS SEGMENT PARA PUBLIC 'DATOS'    ; DECLARACION DE VARIABLES

         VAR_BUCLE1 DB 0                ; VARIABLES UTILIZADAS PARA SIMULAR 
         VAR_BUCLE2 DB 0                ; EL BUCLE DE ESPERA
         VAR_BUCLE3 DB 0
         DIRPAN DW ?                    ; VARIABLE EN LA QUE GUARDAMOS LA
                                        ; DIRECCION DE COMIENZO DE LA 
                                        ; PANTALLA
         PALA DB ''
         PELOTA DB 'o'
	 POSICION_PALA DW 37
         JUGADOR DB 'XXXXXX'
   DATOS ENDS

   CODIGO SEGMENT PARA PUBLIC 'CODIGO'
        ASSUME CS:CODIGO, DS:DATOS, SS:PILA

   ARKANO1 PROC FAR
           PUSH DS
           XOR  AX, AX            ; PREPARAMOS RETORNO A DOS
           PUSH AX              

           MOV  AX, DATOS         ; DIRECCIONAMOS A 'DS' NUESTRO SEGMENTO DE
           MOV  DS, AX            ; DATOS
       
           CALL DIRPANT         ; LLAMADA AL PROCEDIMIENTO QUE NOS DARA LA    
           MOV  ES, DIRPAN      ; DIRECCION BASE DE LA PANTALLA QUE GUARDAMOS
                                ; EN EL REGISTRO 'ES'
           
           CALL BLANCOS         ; ESTE PROCEDIMIENTO NOS LIMPIA LA PANTALLA
           
           CALL PR              ; PANTALLA DE PRESENTACION DEL JUEGO


   WHILE_GG:   CMP VAR_BUCLE3, 0FFFFH      
               JE  FIN_WHILE_GG
   WHILE_G:    CMP VAR_BUCLE1, 0FFFFh
               JE  FIN_WHILE_G
   WHILE:      CMP VAR_BUCLE2, 0FFFFh
               JE FIN_WHILE        
               ADD VAR_BUCLE2, 1
               JMP WHILE                        ; BUCLE DE ESPERA QUE SIMULA
   FIN_WHILE:  MOV VAR_BUCLE2, 0                ; LA ENCUESTA DEL TECLADO
               ADD VAR_BUCLE1, 1
               JMP WHILE_G
 FIN_WHILE_G:  MOV VAR_BUCLE1, 0
               MOV VAR_BUCLE2, 0
               ADD VAR_BUCLE3, 1
               JMP WHILE_GG
FIN_WHILE_GG: CALL BLANCOS                      ; LIMPIAMOS LA PANTALLA DE 
                                                ; NUEVO

             MOV  AX, OFFSET JUGADOR            ; APILAMOS LA DIRECCION DE 
             PUSH AX                            ; JUGADOR, PARAMETRO QUE VA A
             CALL PREJUE                        ; UTILIZAR LA RUTINA FAR 
                                                ; 'PREJUE'
             
             MOV  AX, OFFSET PELOTA - OFFSET PALA
             PUSH AX
             MOV  AX, OFFSET PALA
             PUSH AX
             MOV  AX, 37
             PUSH AX                    ; UTILIZAMOS 'MENSAJE' Y 'ESCR_CAR'
             MOV  AX, 21                ; PARA DIBUJAR LA PALA Y LA PELOTA
             PUSH AX
             CALL MENSAJE               
             MOV  AX, 07H
             PUSH AX
             MOV  AL, PELOTA
             PUSH AX
             MOV  AX, 40
             PUSH AX
             MOV  AX, 20
             PUSH AX
             CALL ESCR_CAR

             RET                        ; DEVOLVEMOS EL CONTROL AL S.O.
             
     ARKANO1 ENDP
      CODIGO ENDS
    
             END ARKANO1
