 TITLE ARKANO3

; PROGRAMA PRINCIPAL

        EXTRN BLANCOS: FAR      ; PROCEDIMIENTOS Y VARIABLES EXTERNAS
        EXTRN DIRPANT: FAR      ; UTILIZADAS
        EXTRN MENSAJE: FAR
        EXTRN ESCR_CAR: FAR
        EXTRN LETREL_I: FAR
        EXTRN LEETEC_E: FAR
        EXTRN PR: FAR
        EXTRN PREJUE: FAR
	PUBLIC TIEMPO
	PUBLIC SEGUNDO1
	PUBLIC SEGUNDO2
	PUBLIC MINUTO1
	PUBLIC MINUTO2
	PUBLIC REJ_IP
	PUBLIC REJ_CS
        PUBLIC DIRPAN
        PUBLIC JUGADOR
        PUBLIC TABLA
        PUBLIC TEC_IP
        PUBLIC TEC_CS       
        PUBLIC POSICION_PALA  
        
   PILA SEGMENT PARA STACK 'PILA'        ; DECLARACION DEL SEGMENTO DE PILA
        DB 64 DUP ('PILA....')
   PILA ENDS

   DATOS SEGMENT PARA PUBLIC 'DATOS'     ; DECLARACION DE VARIABLES
     
;  VARIABLE TABLA QUE UTILIZAMOS PARA TRADUCIR EL CODIGO DE RASTREO LEIDO     
      
     TABLA   DB 27,'1234567890-='
             DB 8,9,'QWERTYUIOP[]',13,' '
             DB 'ASDFGHJKL;',' '
             DB '<-XCVBNM,.-',' '
             DB ' ',' '
             DB ' ',13 DUP (' ')     
             DB '+98-456+1230,'
         TIEMPO DB 0                ; VARIABLES UTILIZADAS PARA CONTROL DEL
	 SEGUNDO1 DB 0              ; TIEMPO
	 SEGUNDO2 DB 0
	 MINUTO1 DB 0
	 MINUTO2 DB 0
	 
         REJ_CS DW ?                ; VARIABLES PARA GUARDAR EL 'CS' Y 'IP'
	 REJ_IP DW ?                ; DE LA SUBRUTINA DE ATENCION DEL RELOJ
	 
         DIRPAN DW ?                ; VARIABLE QUE UTILIZAMOS PARA GUARDAR LA 
				    ; DIRECCION BASE DE LA PANTALLA
         PALA DB ''          
         PELOTA DB 'o'
         JUGADOR DB '      '        ; VARIABLE EN LA QUE ALMACENAMOS EL  
                                    ; NOMBRE DEL JUGADOR     

         TEC_IP DW ?                ; VARIABLES PARA GUARDAR EL 'CS' E 'IP'
         TEC_CS DW ?                ; DE LA SUBRUTINA DE ATENCION DEL TECLADO
	 
         POSICION_PALA DW 37
   DATOS ENDS

   CODIGO SEGMENT PARA PUBLIC 'CODIGO'
        ASSUME CS:CODIGO, DS:DATOS, SS:PILA

   ARKANO3 PROC FAR
         
           PUSH DS
           XOR  AX, AX                ; PREPARAMOS RETORNO A DOS
           PUSH AX
           
           MOV  AX, DATOS             ; DIRECCIONAMOS A 'DS' NUESTRO SEGMENTO
           MOV  DS, AX                ; DE DATOS
       
           CALL DIRPANT               ; LLAMADA AL PROCEDIENTO QUE NOS DARA LA
           MOV  ES, DIRPAN            ; DIRECCION BASE DE LA PANTALLA, QUE 
                                      ; GUARDAMOS EN EL REGISTRO 'ES'
            
           CALL BLANCOS               ; LIMPIAMOS LA PANTALLA
           
           CALL PR                    ; PANTALLA DE PRESENTACION DEL JUEGO    
           
           CALL LEETEC_E              ; LEEMOS EL NOMBRE POR ENCUESTA
                      
           CALL BLANCOS               ; LIMPIAMOS DE NUEVO LA PANTALLA     
    
           MOV  AX, OFFSET JUGADOR
           PUSH AX
           CALL PREJUE                ; ESCRIBIMOS EL ESCENARIO DEL JUEGO
             
           MOV  AX, OFFSET PELOTA - OFFSET PALA
           PUSH AX
           MOV  AX, OFFSET PALA
           PUSH AX
           MOV  AX, 37
           PUSH AX                    ; UTILIZAMOS 'MENSAJE' Y 'ESCR_CAR' PARA
           MOV  AX, 21                ; DIBUJAR LA PALA Y LA PELOTA
           PUSH AX
           CALL MENSAJE
           MOV  AX, 07h
           PUSH AX
           MOV  AL, PELOTA
           PUSH AX
           MOV  AX, 40
           PUSH AX
           MOV  AX, 20
           PUSH AX
           CALL ESCR_CAR
           
           CALL LETREL_I             ; GESTION DEL MOVIMIENTO DE LA PALA Y
                                     ; DEL RELOJ POR INTERRUPCION
            
           RET                       ; DEVOLVEMOS EL CONTROL AL S.O
             
     ARKANO3 ENDP
      CODIGO ENDS
    
             END ARKANO3
