 TITLE ARKANO4

; PROGRAMA PRINCIPAL

	EXTRN BLANCOS: FAR      ; PROCEDIMIENTOS Y VARIABLES EXTERNAS
	EXTRN DIRPANT: FAR      ; UTILIZADAS
	EXTRN MENSAJE: FAR
	EXTRN ESCR_CAR: FAR
	EXTRN LETREL_I: FAR
    EXTRN LEETEC_E: FAR
	EXTRN PR: FAR
	EXTRN PREJUE: FAR
	PUBLIC TIEMPO
	PUBLIC SEGUNDO1
	PUBLIC SEGUNDO2
	PUBLIC MINUTO1
	PUBLIC MINUTO2
	PUBLIC REJ_IP
	PUBLIC REJ_CS
	PUBLIC DIRPAN
	PUBLIC JUGADOR
	PUBLIC TABLA
	PUBLIC TEC_IP
	PUBLIC TEC_CS       
	PUBLIC POSICION_PALA  
	PUBLIC T_PELOTA
	PUBLIC MOVI
	PUBLIC COLUMNA_P
	PUBLIC FILA_P
	PUBLIC FILA_AUX
	PUBLIC COL_AUX
	PUBLIC MOV_VERT
	PUBLIC MOV_HORIZ
	PUBLIC N_PUNTOS
	PUBLIC N_PUNTOS1
	PUBLIC N_PUNTOS2
	PUBLIC N_VIDAS
	PUBLIC LAD_BLANCOS
	
   PILA SEGMENT PARA STACK 'PILA'        ; DECLARACION DEL SEGMENTO DE PILA
	DB 64 DUP ('PILA....')
   PILA ENDS

   DATOS SEGMENT PARA PUBLIC 'DATOS'     ; DECLARACION DE VARIABLES
     
;  VARIABLE TABLA QUE UTILIZAMOS PARA TRADUCIR EL CODIGO DE RASTREO LEIDO     
      
     TABLA   DB 27,'1234567890-='
	     DB 8,9,'QWERTYUIOP[]',13,' '
	     DB 'ASDFGHJKL;',' '
	     DB '<-XCVBNM,.-',' '
	     DB ' ',' '
	     DB ' ',13 DUP (' ')     
	     DB '+98-456+1230,'
	 TIEMPO DB 0                ; VARIABLES UTILIZADAS PARA CONTROL DEL
	 SEGUNDO1 DB 0              ; TIEMPO
	 SEGUNDO2 DB 0
	 MINUTO1 DB 0
	 MINUTO2 DB 0
	 T_PELOTA DW 0 
	 MOVI DB 0
	 COLUMNA_P DW 40
	 FILA_P DW 20
	 FILA_AUX DW ?
	 COL_AUX DW ?
	 MOV_VERT DW -1
	 MOV_HORIZ DW -1
	 N_PUNTOS DW 0
	 N_VIDAS DW 9

	 REJ_CS DW ?                ; VARIABLES PARA GUARDAR EL 'CS' Y 'IP'
	 REJ_IP DW ?                ; DE LA SUBRUTINA DE ATENCION DEL RELOJ
	 
	 DIRPAN DW ?                ; VARIABLE QUE UTILIZAMOS PARA GUARDAR LA 
				    ; DIRECCION BASE DE LA PANTALLA
	 PALA DB ''          
	 PELOTA DB 'o'
	 JUGADOR DB '      '        ; VARIABLE EN LA QUE ALMACENAMOS EL  
				    ; NOMBRE DEL JUGADOR     

	 TEC_IP DW ?                ; VARIABLES PARA GUARDAR EL 'CS' E 'IP'
	 TEC_CS DW ?                ; DE LA SUBRUTINA DE ATENCION DEL TECLADO
	 
	 POSICION_PALA DW 37
	 LAD_BLANCOS DB '        '
	 N_PUNTOS1 DW 0
	 N_PUNTOS2 DW 0
     M_FIN DB '****** FIN DEL JUEGO ******'
     M_ABANDONO DB '****** ABANDONO JUEGO ******'

   DATOS ENDS

   CODIGO SEGMENT PARA PUBLIC 'CODIGO'
	ASSUME CS:CODIGO, DS:DATOS, SS:PILA

   ARKANO4 PROC FAR
	 
	   PUSH DS
	   XOR  AX, AX                ; PREPARAMOS RETORNO A DOS
	   PUSH AX
	   
	   MOV  AX, DATOS             ; DIRECCIONAMOS A 'DS' NUESTRO SEGMENTO
	   MOV  DS, AX                ; DE DATOS
       
	   CALL DIRPANT               ; LLAMADA AL PROCEDIENTO QUE NOS DARA LA
	   MOV  ES, DIRPAN            ; DIRECCION BASE DE LA PANTALLA, QUE 
				      ; GUARDAMOS EN EL REGISTRO 'ES'
	    
	   CALL BLANCOS               ; LIMPIAMOS LA PANTALLA
	   
	   CALL PR                    ; PANTALLA DE PRESENTACION DEL JUEGO    
	   CALL LEETEC_E              ; LEEMOS EL NOMBRE POR ENCUESTA
		      
	   CALL BLANCOS               ; LIMPIAMOS DE NUEVO LA PANTALLA     
    
	   MOV  AX, OFFSET JUGADOR
	   PUSH AX
	   CALL PREJUE                ; ESCRIBIMOS EL ESCENARIO DEL JUEGO
	     
	   MOV  AX, OFFSET PELOTA - OFFSET PALA
	   PUSH AX
	   MOV  AX, OFFSET PALA
	   PUSH AX
	   MOV  AX, 37
	   PUSH AX                    ; UTILIZAMOS 'MENSAJE' Y 'ESCR_CAR' PARA
	   MOV  AX, 21                ; DIBUJAR LA PALA Y LA PELOTA
	   PUSH AX
	   CALL MENSAJE
	   MOV  AX, 07h
	   PUSH AX
	   MOV  AL, PELOTA
	   PUSH AX
	   MOV  AX, 40
	   PUSH AX
	   MOV  AX, 20
	   PUSH AX
	   CALL ESCR_CAR
	   
	   CALL LETREL_I             ; GESTION DEL MOVIMIENTO DE LA PALA Y
            				     ; DEL RELOJ POR INTERRUPCION
       MOV  AX, N_PUNTOS1        ; COMPROBAMOS SI EL NUMERO DE PUNTOS
       CMP  AX, 0                ; COINCIDE CON EL CORRESPONDIENTE A TODOS 
       JNE  MIRAR_VIDAS          ; LOS LADRILLOS
       MOV  AX, N_PUNTOS2       
       CMP  AX, 9
       JNE  MIRAR_VIDAS          ; EN CASO CONTRARIO, SALTAMOS A MIRAR LAS
                                 ; VIDAS

       MOV  AX, 27
       PUSH AX
       MOV  AX, OFFSET M_FIN
       PUSH AX
       MOV  AX, 25
       PUSH AX                   ; EN CASO AFIRMATIVO, ESCRIBIMOS EL 
       MOV  AX, 15               ; MENSAJE DEL FINAL DEL JUEGO EN PANTALLA
       PUSH AX
       CALL MENSAJE
       JMP  FIN

MIRAR_VIDAS:                     ; MIRAR SI AUN LE QUEDAN VIDAS
       MOV  AX, N_VIDAS
       CMP  AX, 0
       JNE  CASO_F
       MOV  AX, 27
       PUSH AX
       MOV  AX, OFFSET M_FIN
       PUSH AX
       MOV  AX, 25
       PUSH AX
       MOV  AX, 15
       PUSH AX
       CALL MENSAJE
       JMP  FIN

CASO_F:MOV  AX, 28               ; HEMOS SALIDO AL PULSAR 'F', Y HACEMOS
       PUSH AX                   ; ECO DE ELLO EN PANTALLA
       MOV  AX, OFFSET M_ABANDONO
       PUSH AX
       MOV  AX, 25
       PUSH AX
       MOV  AX, 15
       PUSH AX
       CALL MENSAJE
         
FIN:   RET                       ; DEVOLVEMOS EL CONTROL AL S.O
	     
     ARKANO4 ENDP
      CODIGO ENDS
    
	     END ARKANO4
