TITLE DIRPANT

; PROCEDIMIENTO CON EL CUAL OBTENEMOS LA DIRECCION BASE DE LA PANTALLA

     EXTRN DIRPAN:WORD          ; VARIABLE GLOBAL EXTERNA

     CODIGO SEGMENT PARA 'CODIGO'
          ASSUME  CS:CODIGO

     PUBLIC DIRPANT

     DIRPANT PROC FAR

          PUSH BP               ; ENLACE DINAMICO
          MOV  BP, SP

          PUSH AX               ; SALVAMOS EL ESTADO
          
          XOR  AX, AX           ; SE INICIALIZA 'ES' COMO 0
          MOV  ES, AX

          MOV  AL, ES:[449H]     ; POSICION DE MEMORIA EN LA QUE SE MIRA
          CMP  AL, 7             ; PARA VER QUE MODO DE VIDEO TIENE EL 
                                 ; ORDENADOR
          JE   BCERO
          CMP  AL, 2
          JE   BOCHO
          CMP  AL, 3
          JE   BOCHO
          JMP  ERROR
  BCERO:  MOV  AX, 0B000H        ; MONOCROMO, HERCULES
          JMP  FIN
  BOCHO:  MOV  AX, 0B800H        ; CGA
          JMP  FIN
  ERROR:  MOV  AX, 0H
  FIN:    MOV  DIRPAN, AX       ; SE ASIGNA A DIRPAN LA DIRECCION BASE DE LA
                                ; PANTALLA MAPEADA

          POP AX                ; RESTAURAR EL ESTADO
          POP BP

          RET                   ; DEVOLMEMOS EL CONTROL

 DIRPANT  ENDP
 CODIGO   ENDS

          END                          
         