
 TITLE LAD_PEL

; PROCEDIMIENTO QUE CONTROLA SI LA PELOTA PEGA EN ALGUN LADRILLO O NO

        EXTRN MENSAJE: FAR
        EXTRN ESCR_CAR: FAR
        EXTRN CAR_MEM: FAR
        EXTRN N_PUNTOS: WORD
        EXTRN MOVI: BYTE
        EXTRN FILA_AUX: WORD
        EXTRN COL_AUX: WORD
        EXTRN FILA_P: WORD
        EXTRN COLUMNA_P: WORD
        EXTRN MOV_VERT: WORD
        EXTRN MOV_HORIZ: WORD
        EXTRN LAD_BLANCOS: BYTE
        EXTRN N_PUNTOS1: WORD
        EXTRN N_PUNTOS2: WORD
        EXTRN BIP: FAR
                              
        CODIGO SEGMENT PARA PUBLIC 'CODIGO'
                ASSUME CS:CODIGO

        PUBLIC LAD_PEL

        LAD_PEL PROC FAR

                PUSH BP                 ;ENLACE DINAMICO
                MOV  BP, SP

                PUSH CX
                PUSH AX                 ; SALVAMOS EL ESTADO

                CMP  MOVI, 1
                JE   FIN_1_2
                
                SUB  SP, 2              ; RESERVAMOS UN ESPACIO EN LA PILA
                MOV  AX, FILA_AUX
                PUSH AX
                MOV  AX, COL_AUX
                PUSH AX
                CALL CAR_MEM
                POP  AX                 ; GUARDAMOS EN 'AX' EL CARACTER DE 
                                        ; MEMORIA EN ESA POSICION

                MOV  CX, AX                                        
                MOV  AX, 07H
                PUSH AX
                PUSH CX
                MOV  AX, 79
                PUSH AX
                MOV  AX, 2
                PUSH AX
                CALL ESCR_CAR

                MOV  AX, CX
                CMP  AL, 0DBH
                JE   INIC
                CMP  AL, 0B2H
                JE   INIC
     FIN_1_2:   JMP  FIN_1
        
   ; LLEGAMOS HASTA AQUI SI SE TRATA DE UN LADRILLO
        INIC:   CALL BIP
                MOV  AX, COL_AUX
                CMP  AX, 9
                JE   LAT_IZ
                CMP  AX, 17
                JE   LAT_IZ
                CMP  AX, 25
                JE   LAT_IZ
                CMP  AX, 33
                JE   LAT_IZ
                CMP  AX, 41
                JE   LAT_IZ
                CMP  AX, 49
                JE   LAT_IZ
                CMP  AX, 57
                JE   LAT_IZ
                CMP  AX, 65
                JE   LAT_IZ
                CMP  AX, 8
                JE   LAT_DR
                CMP  AX, 16
                JE   LAT_DR
                CMP  AX, 24
                JE   LAT_DR
                CMP  AX, 32
                JE   LAT_DR
                CMP  AX, 40
                JE   LAT_DR
                CMP  AX, 48
                JE   LAT_DR
                CMP  AX, 56
                JE   LAT_DR
                CMP  AX, 64
                JE   LAT_DR
                MOV  AX, FILA_AUX
                CMP  AX, 2
                JE   ABAJO
                CMP  AX, 4
                JE   ABAJO
                CMP  AX, 6
                JE   ABAJO
                CMP  AX, 8
                JE   ABAJO
                CMP  AX, 3
                JE   ARRIBA
                CMP  AX, 5
                JE   ARRIBA
                CMP  AX, 7
                JE  ARRIBA 
              
        FIN_1:  JMP FIN_2          
                
       LAT_IZ:  MOV  MOV_HORIZ, -1
                TEST FILA_AUX,01H
                JZ   ACTUALIZAR
                ADD  FILA_AUX, 1
                JMP  ACTUALIZAR
       LAT_DR:  MOV  MOV_HORIZ, 1
                SUB  COL_AUX, 7
                TEST FILA_AUX,01H
                JZ   ACTUALIZAR
                ADD  FILA_AUX, 1  
                JMP  ACTUALIZAR
        ABAJO:  MOV  MOV_VERT, 1
                MOV  AX, COL_AUX
                AND  AX, 0F8H
                INC  AX
                MOV  COL_AUX, AX
                JMP  ACTUALIZAR
        ARRIBA: MOV  MOV_VERT, -1
                ADD  FILA_AUX, 1
                MOV  AX, COL_AUX
                AND  AX, 0F8H
                INC  AX
                MOV  COL_AUX, AX
                JMP  ACTUALIZAR
                        
        FIN_2:  JMP  FIN
                
  ACTUALIZAR:   MOV  AX, 8                      ; BORRAMOS EL LADRILLO
                PUSH AX
                MOV  AX, OFFSET LAD_BLANCOS 
                PUSH AX
                MOV  AX, COL_AUX
                PUSH AX
                MOV  AX, FILA_AUX
                PUSH AX
                CALL MENSAJE
                MOV  AX, 8
                PUSH AX
                MOV  AX, OFFSET LAD_BLANCOS
                PUSH AX
                MOV  AX, COL_AUX
                PUSH AX
                MOV  AX, FILA_AUX
                DEC  AX
                PUSH AX
                CALL MENSAJE
                
                MOV  AX, 07h            ; BORRAMOS LA PELOTA
                PUSH AX
                MOV  AX, ' '
                PUSH AX
                MOV  AX, COLUMNA_P
                PUSH AX
                MOV  AX, FILA_P
                PUSH AX
                CALL ESCR_CAR
                
                MOV  AX, 07H
                PUSH AX
                MOV  AX, 'o'
                PUSH AX
                MOV  AX, COLUMNA_P
                ADD  AX, MOV_HORIZ
                MOV  COLUMNA_P, AX
                MOV  AX, COLUMNA_P
                PUSH AX
                MOV  AX, FILA_P
                ADD  AX, MOV_VERT
                MOV  FILA_P,AX
                MOV  AX, FILA_P
                PUSH AX
                CALL ESCR_CAR 
                
                  
                
; ACTUALIZAR LOS PUNTOS

                MOV  AX, 10
                SUB  AX, FILA_AUX
                SAR  AX, 1
                MOV  N_PUNTOS, AX
                
                MOV  CX, N_PUNTOS
       WHILE:   CMP  CX, 0
                JE   FIN_WHILE
                CMP  N_PUNTOS1, 9
                JE   ACT_N_PUNTOS2
                ADD  N_PUNTOS1, 1
                DEC  CX
                JMP  WHILE
                
ACT_N_PUNTOS2:  ADD  N_PUNTOS2, 1
                MOV  N_PUNTOS1, 0
                DEC  CX
                JMP  WHILE 
       
     FIN_WHILE: JMP ESCRIBIR
     
   ESCRIBIR:    MOV  AX, 07h
                PUSH AX
                MOV  AX, N_PUNTOS1
                XOR  AX, 30h
                PUSH AX
                MOV  AX, 56
                PUSH AX
                MOV  AX, 23
                PUSH AX
                CALL ESCR_CAR

                MOV  AX, 07h
                PUSH AX
                MOV  AX, N_PUNTOS2
                XOR  AX, 30h
                PUSH AX
                MOV  AX, 55
                PUSH AX
                MOV  AX, 23
                PUSH AX
                CALL ESCR_CAR                
                MOV  N_PUNTOS, 0
                
                MOV  MOVI, 1

         FIN:   POP  AX                 ; RESTAURAMOS EL ESTADO
                POP  CX
                POP  BP
         
                RET                     ; DEVOLVEMOS EL CONTROL

        LAD_PEL ENDP
         CODIGO ENDS

                END
