 TITLE LAD_PEL

; PROCEDIMIENTO QUE CONTROLA SI LA PELOTA PEGA EN ALGUN LADRILLO O NO

        EXTRN MENSAJE: FAR
        EXTRN ESCR_CAR: FAR
        EXTRN CAR_MEM: FAR
        EXTRN N_PUNTOS: WORD
        EXTRN MOVI: BYTE
        EXTRN FILA_AUX: WORD
        EXTRN COL_AUX: WORD
        EXTRN FILA_P: WORD
        EXTRN COLUMNA_P: WORD
        EXTRN MOV_VERT: WORD
        EXTRN MOV_HORIZ: WORD
        EXTRN LAD_BLANCOS: BYTE
                         
        CODIGO SEGMENT PARA PUBLIC 'CODIGO'
                ASSUME CS:CODIGO

        PUBLIC LAD_PEL

        LAD_PEL PROC FAR

                PUSH BP                 ;ENLACE DINAMICO
                MOV  BP, SP

                PUSH CX
                PUSH AX                 ; SALVAMOS EL ESTADO

                CMP  MOVI, 1
                JE   FIN_1
                
                SUB  SP, 2              ; RESERVAMOS UN ESPACIO EN LA PILA
                MOV  AX, FILA_AUX
                PUSH AX
                MOV  AX, COL_AUX
                PUSH AX
                CALL CAR_MEM
                POP  AX                 ; GUARDAMOS EN 'AX' EL CARACTER DE 
                                        ; MEMORIA EN ESA POSICION

                MOV  CX, AX                                        
                MOV  AX, 07H
                PUSH AX
                PUSH CX
                MOV  AX, 79
                PUSH AX
                MOV  AX, 2
                PUSH AX
                CALL ESCR_CAR

                MOV  AX, CX
                CMP  AL, 0DBH
                JE   INIC
                CMP  AL, 0B2H
                JE   INIC
                JMP  FIN_1
        
        INIC:   MOV  AX, COL_AUX
                AND  AX, 0F8h      ; MULTIPLICAMOS POR 11111000
                CMP  AX, COL_AUX
                JNG  CONTINUAR
                SUB  AX, 11
                MOV  COL_AUX, AX
                
    CONTINUAR:  TEST FILA_AUX, 01h
                JZ   END_IF
                SUB  FILA_AUX, 1
                JMP  END_IF

        FIN_1:  JMP  FIN
                
       END_IF:  MOV  AX, 8                      ; BORRAMOS EL LADRILLO
                PUSH AX
                MOV  AX, OFFSET LAD_BLANCOS 
                PUSH AX
                MOV  AX, COL_AUX
                PUSH AX
                MOV  AX, FILA_AUX
                PUSH AX
                CALL MENSAJE
                MOV  AX, 8
                PUSH AX
                MOV  AX, OFFSET LAD_BLANCOS
                PUSH AX
                MOV  AX, COL_AUX
                PUSH AX
                MOV  AX, FILA_AUX
                DEC  AX
                PUSH AX
                CALL MENSAJE

                MOV  AX, 10             ; CALCULAMOS LOS PUNTOS
                ADD  FILA_AUX, 1
                SUB  AX, FILA_AUX
                ADD  N_PUNTOS, AX
                MOV  AX, MOV_VERT
                MOV  CX, -1
                MUL  CX
                MOV  MOV_VERT, AX       ; CAMBIAMOS LA DIRECCION DE LA PELOTA 
              
                MOV  AX, 07h            ; BORRAMOS LA PELOTA
                PUSH AX
                MOV  AX, ' '
                PUSH AX
                MOV  AX, COLUMNA_P
                PUSH AX
                MOV  AX, FILA_P
                PUSH AX
                CALL ESCR_CAR
                
                MOV  MOVI, 1

         FIN:   POP  AX                 ; RESTAURAMOS EL ESTADO
                POP  CX
                POP  BP
         
                RET                     ; DEVOLVEMOS EL CONTROL

        LAD_PEL ENDP
         CODIGO ENDS

                END
