TITLE LETREL_I

;   PROCEDIMIENTO DONDE ESTABLECEMOS EN EL V.I LA SUBRUTINA DE ATENCION DE
;   TECLADO PROPIA Y UNA SUBRUTINA DE RELOJ TAMBIEN PROPIA A PARTE DE LA DEL
;   SISTEMA 
    
      EXTRN DIRPANT: FAR
      EXTRN LEECAR_I: FAR
      EXTRN TEC_IP:  WORD
      EXTRN TEC_CS:  WORD               ; SUBRUTINAS Y VARIABLES EXTERNAS
      EXTRN DIRPAN: WORD                ; UTILIZADAS 
      EXTRN REJ_IP: WORD
      EXTRN REJ_CS: WORD
      EXTRN RELOJ: FAR
      EXTRN MOV_PELOTA: FAR
      EXTRN N_PUNTOS1: WORD
      EXTRN N_PUNTOS2: WORD
      EXTRN N_VIDAS: WORD
      
    CODIGO SEGMENT PARA PUBLIC 'CODIGO'
        ASSUME CS:CODIGO

  	PUBLIC LETREL_I

    	LETREL_I PROC FAR
        
        PUSH BP
        MOV  BP, SP                 ; ENLACE DINAMICO
        
        PUSH AX
        PUSH BX                     ; SALVAMOS ESTADO
        
        CLI                         ; INHIBIMOS LAS INTERUPCIONES
        
        MOV  BX, 36
        MOV  AX, 0
        MOV  ES, AX
        MOV  AX, ES:[BX]              
        MOV  TEC_IP, AX             ; SALVAMOS EL 'IP' DE LA SUBRUTINA DE 
                                    ; ATENCION DE TECLADO DEL SISTEMA
        MOV  AX, ES:[BX+2]
        MOV  TEC_CS, AX             ; SALVAMOS EL 'CS' DE LA SUBRUTINA DE 
                                    ; ATENCION DE TECLADO DEL SISTEMA
        MOV  AX, OFFSET LEECAR_I
        MOV  ES:[BX], AX            ; ESTABLECEMOS EL 'IP' DE NUESTRA PROPIA
                                    ; SUBRUTINA DE ATENCION
        MOV  AX, SEG LEECAR_I
        MOV  ES:[BX+2], AX          ; ESTABLECEMOS EL 'CS' DE NUESTRA PROPIA
                                    ; SUBRUTINA DE ATENCION 
	MOV  BX, 1Ch*4
	MOV  AX, ES:[BX]
	MOV  REJ_IP, AX             ; SALVAMOS EL 'IP' DE LA SUBRUTINA DE
                                    ; ATENCION DE RELOJ DEL SISTEMA 
	MOV  AX, ES:[BX+2]
	MOV  REJ_CS, AX             ; SALVAMOS EL 'CS' DE LA SUBRUTINA DE
                                    ; ATENCION DE RELOJ DEL SISTEMA
	MOV  AX, OFFSET RELOJ
	MOV  ES:[BX], AX            ; ESTABLECEMOS EL 'IP' DE NUESTRA PROPIA
                                    ; SUBRUTINA DE ATENCION
	MOV  AX, SEG RELOJ
	MOV  ES:[BX+2], AX          ; ESTABLECEMOS EL 'CS' DE NUESTRA PROPIA
                                    ; SUBRUTINA DE ATENCION  
        
        STI                         ; DESINHIBIMOS LAS INTERUPCIONES
        CALL DIRPANT
        MOV  ES,DIRPAN              
        MOV  AL, -1
   ENCU_F:
        CMP  AL, 46h                 ; BUCLE DE ESPERA DE LA PULSACION DE LA
        JE   FIN_ENCU                ; TECLA 'F' PARA FINALIZAR
        MOV  AX, N_VIDAS
        CMP  AX, 0
        JE   FIN_ENCU
        MOV  AX, N_PUNTOS1
        CMP  AX, 0
        JNE  P_ENCU_F
        MOV  AX, N_PUNTOS2
        CMP  AX, 9
        JE   FIN_ENCU
        JMP  P_ENCU_F
                
 P_ENCU_F:CALL MOV_PELOTA
        JMP ENCU_F
 FIN_ENCU:CLI                       ; INHIBICION DE LAS INTERUPCIONES
        
        XOR  AX, AX
        MOV  ES, AX
        MOV  BX, 36
        MOV  AX, TEC_IP
        MOV  ES:[BX], AX            ; REESTABLECEMOS EL 'IP' DE LA SUBRUTINA
                                    ; DE ATENCION DE TECLADO DEL SISTEMA  
        MOV  AX, TEC_CS
        MOV  ES:[BX+2], AX          ; REESTABLECEMOS EL 'CS' DE LA SUBRUTINA
                                    ; DE ATENCION DE TECLADO DEL SISTEMA 
        MOV  BX, 1Ch*4
	MOV  AX, REJ_IP
	MOV  ES:[BX], AX            ; REESTABLECEMOS EL 'IP' DE LA SUBRUTINA
                                    ; DE ATENCION DE RELOJ DEL SISTEMA
	MOV  AX, REJ_CS
	MOV  ES:[BX+2], AX          ; REESTABLECEMOS EL 'CS' DE LA SUBRUTINA
                                    ; DE ATENCION DE RELOJ DEL SISTEMA 
	
        STI                         ; DESINHIBIMOS LAS INTERUPCIONES 
        
	CALL DIRPANT
        
	MOV ES,DIRPAN
        POP BX
        POP AX                      ; RESTAURAMOS ESTADO
        POP BP
        
        RET                         ; RETORNO DE CONTROL
        LETREL_I ENDP
          CODIGO ENDS
                  
                  END
