TITLE LEETEC_E
  
;   PROCEDIMIENTO QUE NOS GESTIONA LA LECTURA POR ENCUESTA DEL TECLADO  

     EXTRN LEECAR_E: FAR
     EXTRN ESCR_CAR: FAR
     EXTRN JUGADOR: BYTE
     EXTRN TABLA: BYTE     
     DATOS SEGMENT PARA PUBLIC 'DATOS'    ; DECLARACION DE UN SEGMENTO DE
                                          ; DATOS PROPIO DE ESTA SUBRUTINA
             FILA DB 22
             COLUMNA DB 30
             NUM_CARACT DB 0
     
     DATOS ENDS

     CODIGO SEGMENT PARA PUBLIC 'CODIGO'
          ASSUME CS:CODIGO,DS:DATOS

     	PUBLIC LEETEC_E

     	LEETEC_E PROC FAR
        
          PUSH AX  
          PUSH BX          ; SALVAMOS ESTADO
          PUSH CX
          PUSH DS

          MOV  AX, DATOS                 
          MOV  DS, AX       ; ACTUALIZAMOS  'DS' CON NUESTRO SEGMENTO DE DATOS
 
     ;INHIBICION DE LA INTERRUPCION DE TECLADO

          IN   AL, 21h      ; LEER IMR DEL CONTROLADOR DE INTERRUPCIONES
          OR   AL, 02h 
          OUT  21H, AL      ; PONER A 1 EL SEGUNDO BIT DE IMR BIT 
                            ; CORRESPONDIENTE A LA INTERRUPCION DE TECLADO

   ENCU:  MOV  AL, 0Ah
          OUT  20H, AL      ;SELECCION DEL IRR EN EL REGISTRO DE CONTROL
          IN   AL, 20h      ;AL=IRR, LEYENDO EL REGISTRO DE CONTROL
          TEST AL, 02h      

          JZ   ENCU         ; SI ESTA A 1 ES QUE NO SE HA PULSADO NADA

          CALL LEECAR_E     ; DEVUELVE EN 'AL' EL CODIGO DE RASTREO;

          CMP  AL, 28       ; CONTROLAMOS SI LA TECLA PULSADA ES (CR) PARA 
                            ; PARAR EN EL CASO DE SER CIERTO
          
          JE   FIN         
          CMP  AL, -1       ;SI ES UN -1,SERIA UN "BREAK" Y LO IGNORAMOS
          JE   ENCU   
          INC  NUM_CARACT   ; AUMENTAMOS LA VARIABLE NUM_CARACT QUE ES 
                              ; DONDE CONTROLAMOS EL NUMERO DE TECLAS PULSADAS
          MOV  BL, NUM_CARACT
          CMP  BL, 7           ; COMPARAMOS CON 7 SI ES IGUAL SALTAMOS AL FIN
                               ; PORQUE CONSIDERAMOS QUE EL NOMBRE PUEDE TENER
                               ; DE EXTENSION MAXIMA 6 CARACTERES 
          JE   FIN     
          SUB  AL, 1           ; TRADUCCION DE LA TECLA PULSADA
          LEA  BX, TABLA
          XLAT                 ; EN 'AL'=CARACTER
          MOV  BX, 0
          MOV  BL, NUM_CARACT 
          DEC  BX 
          MOV  JUGADOR[BX], AL ; INTRODUCIMOS EN LA POSICION ADECUADA DE LA 
                               ; VARIABLE 'JUGADOR' EL CARACTER PULSADO  

          MOV  AX, 07h
          PUSH AX              ; PARAMETRO ATRIBUTO
          MOV  AL, JUGADOR[BX]
          PUSH AX              ; PARAMETRO CARACTER
           
          MOV  AL, COLUMNA
          ADD  AL, NUM_CARACT
          PUSH AX              ; PARAMETRO COLUMNA
          MOV  AL, FILA
          PUSH AX              ; PARAMETRO FILA
          CALL ESCR_CAR
          JMP  ENCU            ; VOLVEMOS A LEER OTRO CARACTER

     FIN: IN   AL, 21H         ; ACCEDER A IMR
          AND  AL, 11111101B
          OUT  21H, AL         ; HABILITAR LAS INTERRUPCIONES DEL TECLADO

          POP  DS
          POP  CX              ; REESTABLECEMOS EL ESTADO
          POP  BX
          POP  AX

          RET                  ; DEVOLUCION DEL CONTROL
     
	LEETEC_E ENDP
          CODIGO ENDS     
                 
                 END 
