 TITLE PALA

; PROCEDIMIENTO QUE CONTROLA SI LA PELOTA PEGA EN LA PALA O NO

        EXTRN ESCR_CAR: FAR
        EXTRN CAR_MEM: FAR
        EXTRN MOVI: BYTE
        EXTRN FILA_AUX: WORD
        EXTRN COL_AUX: WORD
        EXTRN FILA_P: WORD
        EXTRN COLUMNA_P: WORD
        EXTRN MOV_VERT: WORD
        EXTRN MOV_HORIZ: WORD
        EXTRN POSICION_PALA: WORD
        EXTRN BIP: FAR                 
                
        CODIGO SEGMENT PARA PUBLIC 'CODIGO'
                ASSUME CS:CODIGO

        PUBLIC PALA

        PALA PROC FAR

                PUSH BP                 ;ENLACE DINAMICO
                MOV  BP, SP

                PUSH AX                 ; SALVAMOS EL ESTADO
                PUSH CX
                
                SUB  SP, 2              ; RESERVAMOS UN ESPACIO EN LA PILA
                MOV  AX, FILA_AUX
                PUSH AX
                MOV  AX, COL_AUX
                PUSH AX
                CALL CAR_MEM
                POP  AX                 ; GUARDAMOS EN 'AX' EL CARACTER DE 
                                        ; MEMORIA EN ESA POSICION
                CMP  AL, 220
                JNE  FIN1
     
                MOV  AX, POSICION_PALA
                ADD  AX, 3
                CMP  AX, COL_AUX
                JE   CENTRO
                MOV  AX, POSICION_PALA
                CMP  AX, COL_AUX
                JNE  DR_PALA1
                DEC  AX
                CMP  AX, COLUMNA_P
                JE   IZQ_PALA
      DR_PALA1: MOV  AX, POSICION_PALA 
                ADD  AX, 6
                CMP  AX, COL_AUX
                JNE  DE_CENTRO1
                INC  AX
                CMP  AX, COLUMNA_P
                JE   DR_PALA
   DE_CENTRO1:  MOV  AX, MOV_HORIZ
                CMP  AX, 0
                JE   DE_CENTRO
                MOV  AX, MOV_VERT
                MOV  CX, -1
                MUL  CX
                MOV  MOV_VERT, AX
                JMP  ACTUALIZAR
                
    DE_CENTRO:  MOV  MOV_VERT, -1
                MOV  AX, POSICION_PALA
                ADD  AX, 4
                CMP  AX, COLUMNA_P
                JNG  IZDA
                MOV  MOV_HORIZ, -1
                JMP  ACTUALIZAR
        IZDA:   MOV  MOV_HORIZ, 1
                JMP  ACTUALIZAR         
                
         FIN1:  JMP FIN
    IZQ_PALA:   MOV  MOV_VERT, -1  
                MOV  MOV_HORIZ, -1
                JMP  ACTUALIZAR

     DR_PALA:   MOV  MOV_VERT, -1 
                MOV  MOV_HORIZ, 1
                JMP  ACTUALIZAR
     
     CENTRO:    MOV  MOV_HORIZ, 0
                MOV  AX, MOV_VERT
                MOV  CX, -1
                MUL  CX
                MOV  MOV_VERT, AX
                       
   ACTUALIZAR:  MOV  AX, 07h            ; BORRAMOS LA PELOTA
                PUSH AX
                MOV  AX, ' '
                PUSH AX
                MOV  AX, COLUMNA_P
                PUSH AX
                MOV  AX, FILA_P
                PUSH AX
                CALL ESCR_CAR
                
                MOV  AX, 07h
                PUSH AX                 ; ESCRIBIMOS LA PELOTA EN SU NUEVA
                MOV  AX, 'o'            ; POSICION EN LA PANTALLA
                PUSH AX
                MOV  AX, COLUMNA_P
                ADD  AX, MOV_HORIZ
                MOV  COLUMNA_P, AX
                MOV  AX, COLUMNA_P 
                PUSH AX
                MOV  AX, FILA_P
                ADD  AX, MOV_VERT
                MOV  FILA_P, AX
                MOV  AX, FILA_P
                PUSH AX
                CALL ESCR_CAR
                CALL BIP

                MOV  MOVI, 1

         FIN:   POP  CX
                POP  AX                 ; RESTAURAMOS EL ESTADO
                POP  BP
         
                RET                     ; DEVOLVEMOS EL CONTROL

        PALA ENDP
         CODIGO ENDS

                END
