TITLE PREJUE

; PROCEDIMIENTO QUE ESCRIBE LA PANTALLA DEL JUEGO 


        EXTRN HORIZ: FAR	; PROCEDIMIENTOS EXTERNOS QUE SE VAN A 
        EXTRN VERT: FAR		; UTILIZAR EN ESTA SUBRUTINA
        EXTRN ESCR_CAR: FAR
        EXTRN MENSAJE: FAR
        EXTRN LADRILLO: FAR        
        
        DATO SEGMENT PARA PUBLIC 'DATO'
                NOMBRE DB 'NOMBRE:      '
                FILA_MENSAJE DB 23
                COLUMNA_NOMBRE DB 4
                VIDAS DB 'VIDAS: 9'
                COLUMNA_VIDAS DB 19
                ARKANOID DB '** ARKANOID **'
                COLUMNA_AR DB 30
                PUNTOS DB 'PUNTOS:PP'
                COLUMNA_PU DB 48
                TIEMPO_M DB 'TIEMPO:MM/SS'
                COLUMNA_TI DB 60        

        DATO ENDS        
        
        CODIGO SEGMENT PARA PUBLIC 'CODIGO'
               ASSUME DS:DATO, CS:CODIGO

        PUBLIC PREJUE

        PREJUE PROC FAR

                PUSH BP			; ENLACE DINAMICO
                MOV  BP,SP         
                
		PUSH AX			; GUARDAMOS EL ESTADO 
                PUSH DS
                         
                MOV  AX, DATO		; ASIGNAMOS EL NUEVO SEGMENTO DE 
                MOV  DS, AX		; DATOS
                
;ESCRIBIMOS LAS LINEAS HORIZONTALES

		MOV  AX, 0
                PUSH AX
                CALL HORIZ
                MOV  AX, 22
                PUSH AX
                CALL HORIZ
                MOV  AX, 24
                PUSH AX
                CALL HORIZ
                MOV  AX, 0
                PUSH AX
                CALL VERT
                MOV  AX, 73
                PUSH AX
                CALL VERT   

;SE VAN A COLOCAR LAS CUATRO ESQUINAS EN LAS BARRAS LATERALES

                MOV  AX, 07h
                PUSH AX
                MOV  AX, 0C9h
                PUSH AX
                MOV  AX, 0
                PUSH AX
                PUSH AX
                CALL ESCR_CAR
                MOV  AX, 07h
                PUSH AX
                MOV  AX, 0BCh
                PUSH AX
                MOV  AX, 73
                PUSH AX
                MOV  AX, 24
                PUSH AX
                CALL ESCR_CAR
                MOV  AX, 07h
                PUSH AX
                MOV  AX, 0BBh
                PUSH AX
                MOV  AX, 73
                PUSH AX
                MOV  AX, 0
                PUSH AX
                CALL ESCR_CAR
                MOV  AX, 07h
                PUSH AX
                MOV  AX, 0C8h
                PUSH AX
                MOV  AX, 0       
                PUSH AX
                MOV  AX, 24
                PUSH AX
                CALL ESCR_CAR     
                MOV  AX, 07h
                PUSH AX
                MOV  AX, 0CCh
                PUSH AX
                MOV  AX, 0
                PUSH AX
                MOV  AX, 22
                PUSH AX
                CALL ESCR_CAR
                MOV  AX, 07h
                PUSH AX
                MOV  AX, 0B9h
                PUSH AX
                MOV  AX, 73
                PUSH AX
                MOV  AX, 22
                PUSH AX
                CALL ESCR_CAR
                
; UNA VEZ DIBUJADO EL CUADRO LO RELLENAMOS DE LADRILLOS

                CALL LADRILLO

; DESPUES SE ESCRIBE LA LINEA DE ESTADO AL PIE DE LA PANTALLA

                MOV  AX, OFFSET FILA_MENSAJE - OFFSET NOMBRE
                PUSH AX
                MOV  AX, OFFSET NOMBRE
                PUSH AX
                MOV  AL, COLUMNA_NOMBRE
                PUSH AX
                MOV  AL, FILA_MENSAJE
                PUSH AX
                CALL MENSAJE
                MOV  AX, 6
                PUSH AX
                MOV  AX, SS:-4[BP]
                MOV  DS, AX 
                MOV  AX, SS:6[BP]
                PUSH AX
                MOV  AX, 11
                PUSH AX
                MOV  AX, 23
                PUSH AX
                CALL MENSAJE 
                MOV  AX, DATO
                MOV  DS, AX 
                MOV  AX, OFFSET COLUMNA_VIDAS - OFFSET VIDAS
                PUSH AX
                MOV  AX, OFFSET VIDAS
                PUSH AX
                MOV  AL, COLUMNA_VIDAS
                PUSH AX
                MOV  AL, FILA_MENSAJE
                PUSH AX
                CALL MENSAJE
                MOV  AX, OFFSET COLUMNA_AR - OFFSET ARKANOID
                PUSH AX
                MOV  AX, OFFSET ARKANOID
                PUSH AX
                MOV  AL, COLUMNA_AR
                PUSH AX
                MOV  AL, FILA_MENSAJE
                PUSH AX
                CALL MENSAJE
                MOV  AX, OFFSET COLUMNA_PU -  OFFSET PUNTOS
                PUSH AX
                MOV  AX, OFFSET PUNTOS
                PUSH AX
                MOV  AL, COLUMNA_PU
                PUSH AX
                MOV  AL, FILA_MENSAJE
                PUSH AX
                CALL MENSAJE
                MOV  AX, OFFSET COLUMNA_TI - OFFSET TIEMPO_M
                PUSH AX
                MOV  AX, OFFSET TIEMPO_M
                PUSH AX
                MOV  AL, COLUMNA_TI
                PUSH AX
                MOV  AL, FILA_MENSAJE
                PUSH AX
                CALL MENSAJE

                POP  DS		; SE REESTABLECE EL SEGMENTO DE DATOS

                POP  AX		; REESTABLECEMOS EL ESTADO
                POP  BP
                
		RET  2		; DEVOLVEMOS EL CONTROL

         PREJUE ENDP
         CODIGO ENDS
                
		END
