 TITLE RELOJ

; ESTA RUTINA CONTROLA LAS INTERRUPCIONES DE RELOJ

	EXTRN ESCR_CAR: FAR		; PROCEDIMIENTOS Y VARIABLES 
	EXTRN TIEMPO: BYTE		; EXTERNOS QUE SE VAN A UTILIZAR
	EXTRN SEGUNDO1: BYTE
	EXTRN SEGUNDO2: BYTE
	EXTRN MINUTO1: BYTE
	EXTRN MINUTO2: BYTE
	EXTRN DIRPAN: WORD
	EXTRN DIRPANT: FAR
        EXTRN T_PELOTA: WORD	
	CODIGO SEGMENT PARA PUBLIC 'CODIGO'
		ASSUME CS:CODIGO
	PUBLIC RELOJ

	RELOJ PROC FAR
		
		PUSH DS			; SALVAR EL ESTADO
		PUSH ES
		PUSH AX
		
		CLI			; INHIBIR LAS INTERRUPCIONES
		
		MOV  AX, SEG TIEMPO	; MOVEMOS EL SEGMENTO DE 'TIEMPO' A AX
		MOV  DS, AX
		CALL DIRPANT
		MOV  ES, DIRPAN		; MOVEMOS A ES LA DIRECCION DE LA
					; PANTALLA QUE NOS HA DEVUELTO DIRPANT
		MOV  AL, TIEMPO
		INC  AL			; INCREMENTAMOS EL CONTADOR DE 'TICS'
		MOV  TIEMPO, AL
                MOV  AX, T_PELOTA
                INC  AX
                MOV  T_PELOTA, AX
                
	  IF:   CMP  TIEMPO, 18		; UNA VEZ ACTUALIZADO EL CONTADOR DE
		JNE  FIN_IF		; 'TICS' COMPROBAMOS SI SE HA CUMPLIDO
		MOV  AL, SEGUNDO1	; UN SEGUNDO, 10 SEGUNDOS, ETC. 
		INC  AL			; ACTUALIZANDO LAS VARIABLES ADECUADAS
		MOV  SEGUNDO1, AL
		MOV  TIEMPO, 0
	IF_S1:  CMP  SEGUNDO1, 10
		JNE  FIN_IF
		MOV  SEGUNDO1, 0
		MOV  AL, SEGUNDO2
		INC  AL
		MOV  SEGUNDO2, AL
	IF_S2:	CMP  SEGUNDO2, 6
		JNE  FIN_IF
		MOV  SEGUNDO2, 0
		MOV  AL, MINUTO1
		INC  AL
		MOV  MINUTO1, AL
	IF_M1:  CMP  MINUTO1, 10
		JNE  FIN_IF
		MOV  MINUTO1, 0
		MOV  AL, MINUTO2
		INC  AL
		MOV  MINUTO2, AL
	IF_M2:  CMP  MINUTO2, 6
		JNE  FIN_IF
		MOV  MINUTO2, 0
		MOV  MINUTO1, 0
		MOV  SEGUNDO1, 0
  		MOV  SEGUNDO2, 0
	FIN_IF: 

; ESCRIBIMOS LA NUEVA HORA  

		MOV  AX, 07h
		PUSH AX
		MOV  AL, SEGUNDO1
		XOR  AL, 30h
		PUSH AX
 		MOV  AX, 71
		PUSH AX
		MOV  AX, 23
		PUSH AX
		CALL ESCR_CAR
		MOV  AX, 07h
		PUSH AX
		MOV  AL, SEGUNDO2
		XOR  AL, 30h
		PUSH AX
 		MOV  AX, 70
		PUSH AX
		MOV  AX, 23
		PUSH AX
		CALL ESCR_CAR
		MOV  AX, 07h
		PUSH AX
		MOV  AL, MINUTO1
		XOR  AL, 30h
		PUSH AX
 		MOV  AX, 68
		PUSH AX
		MOV  AX, 23
		PUSH AX
		CALL ESCR_CAR
		MOV  AX, 07h
		PUSH AX
		MOV  AL, MINUTO2
		XOR  AL, 30h
		PUSH AX
 		MOV  AX, 67
		PUSH AX
		MOV  AX, 23
		PUSH AX
		CALL ESCR_CAR

		IN   AL, 61h    ;SECUENCIA DE STROBE
 		OR   AL, 80h
		OUT  61h, AL
		AND  AL, 7Fh
		OUT  61h, AL

		STI		; DESINHIBIMOS LAS INTERRUPCIONES
		
		POP AX		; REESTABLECEMOS EL ESTADO
		POP ES
		POP DS
		
		IRET		; DEVOLVEMOS EL CONTROL A LA SUBRUTINA 
				; INTERRUMPIDA
	   RELOJ ENDP
          CODIGO ENDS
		 
		 END

