;Fichero: ARKANO2.ASM    Modulo 2 de la prctica orientado a la escritura en
TITLE ARKANO2         ;pantalla y a la lectura por encuesta sobre el teclado.

EXTRN ESCR_CAR:FAR    ;rutina que escribe un carcter por pantalla.
EXTRN DIR_PANT:FAR    ;rutina que calcula el modo de video.
EXTRN DIB_PALA:FAR    ;rutina que dibuja el coche en la posicin (i,j).
EXTRN LEER_NOM:FAR    ;rutina que realiza la encuesta sobre el teclado.
EXTRN LEECAR_E:FAR    ;rutina que lee el cdigo de rastreo de la tecla pulsada
;
PANTALLA SEGMENT AT 0B800H
         DW 80*25 DUP (?)
PANTALLA ENDS
;
PILA     SEGMENT PARA STACK 'PILA'
         DB 64 DUP ('PILA    ')
PILA     ENDS
;
PUBLIC LINEA_HORI,LINEA_VACIA,LINEA_REG1,LINEA_REG2,LINEA_REG3,LINEA_INFO
PUBLIC LIN1_PALA,LIN2_PALA,POSI_PALA,DIRPAN,FIL_PELO,COL_PELO,M,NOM,TABLA
DATOS  SEGMENT PARA PUBLIC 'DATOS'
NOM         DB '        '
TABLA       DB 27,'1234567890-='
            DB 8,9,'QWERTYUIOP[]',13,'*'
            DB 'ASDFGHJKL$;$','*'
            DB '<ZXCVBNM,.-','*'
            DB' ','*'
            DB ' ', 13 DUP ('*')
            DB '789-456+1230'
M DB'۲۲۲۲'
  DB'۲۲۲۲'
  DB'۲۲۲۲'
  DB'۲۲۲۲'
  DB'۲۲۲۲'
  DB'۲۲۲۲'
  DB'۲۲۲۲'
  DB'۲۲۲۲'
FIL_PELO    DB ?
COL_PELO    DB ?
LIN1_PALA   DB 'ͻ'
LIN2_PALA   DB 'ͼ'
POSI_PALA   DB ?
DIRPAN      DW ?
LINEA_HORI  DB '   '
            DB '   '
LINEA_VACIA DB '                                       '
            DB '                                       '
LINEA_REG1  DB '  Teclas de movimiento   :   *O* mover'  
            DB ' izquierda     *P* mover derecha  '     
LINEA_REG2  DB '  Tecla de fin del juego :   *F*      '
            DB '                                  '
LINEA_REG3  DB '  Teclee su nombre y pulse Intro : -  '
            DB '      -                           '
LINEA_INFO  DB ' Nombre:          I  Jugadas:  I  ARKANOID  I'
            DB ' Ptos:0000 I Tiempo:  :    '
DATOS       ENDS
;
CODIGO SEGMENT PARA PUBLIC 'CODIGO'
       ASSUME CS:CODIGO,DS:DATOS,SS:PILA
;
ARKANO2 PROC FAR
;para volver al DOS primero se empila la @ de retorno
       PUSH DS             ;se empila el seg. de datos del DOS
       SUB  AX,AX          ;AX:=0
       PUSH AX             ;se empila el desplazamiento (0)

       MOV AX,DATOS
       MOV DS,AX           ;se inicializa nuestor seg. de datos

       CALL DIR_PANT       ;Calculamos la @ de comienzo da la pantalla
       MOV ES,AX           ;Se inicializa el seg. extra ; ES:= @ pantalla
       CALL PRESENT1       ;Presentacion inicial del juego.
       CALL LEER_NOM       ;Subrutina que escribe el nombre del jugador por
                           ;pantalla y lo guarda en la variable NOM.
       CALL PRESENT2       ;Escribimos la linea permanente de informacim 
                           ;sobre el estado del juego.
       CALL DIB_MURO       ;Subrutina que dibuja el muro incial en pantalla.
       MOV  POSI_PALA,34
       CALL DIB_PALA       ;Subrutina que dibuja la pala en la posicin
                           ;indicada por la variable POSI_PALA.
       MOV  FIL_PELO,18
       MOV  COL_PELO,39
       CALL DIB_PELO       ;Subrutina que dibuja la pelota en la posicin
                           ;que indican FIL_PELO y COL_PELO.
      CALL ESCR_NOM        ;Escribimos de la variable NOM el nombre 
                           ;del jugador tecleado.
       RET                           
ARKANO2 ENDP

;Rutina que realiza la presentacin inicial del juego.
PRESENT1 PROC NEAR
       PUSH BP
       MOV  BP,SP          ;enlace dinamico
       PUSH AX
       PUSH BX
       PUSH DX
       PUSH SI
       PUSH DI             ;salvar registros

       MOV  BX,03H         ;BX:=atributo
       MOV  DI,0           ;inicializamos el contador de filas
WHILE1:CMP  DI,25
       JZ   FINAL1         ;si fila=25 => FIN1
       MOV  SI,0           ;inicializamos el contador de columnas
       
WHILE2:CMP  SI,80
       JZ   FIN2           ;si columna=80 => FIN2
       CMP  DI,0
       JZ   L_HOR          ;si fila=0 o fila= 24=> escribimos linea horizontal
       CMP  DI,24          ;sino escribimos la linea vacia
       JZ   L_HOR
       MOV  AL,DS:LINEA_VACIA[SI] ;escribimos linea vaca y continuamos
       JMP  CONTI
L_HOR: MOV  AL,DS:LINEA_HORI[SI]  ;escribimos linea horizontal y continuamos
       
CONTI: PUSH BX             ;empilamos el atributo
       PUSH AX             ;empilamos el caracter
       PUSH SI             ;empilamos la columna
       PUSH DI             ;empilamos la fila
       CALL ESCR_CAR       ;llamada a subrutina de escritura
       INC  SI             ;incremantamos la columna
       JMP  WHILE2
FIN2:  INC  DI             ;incrementamos la fila
       JMP  WHILE1
       
;escribimos reglas del juego
FINAL1:MOV  BX,0FH
       MOV  DI,12
       MOV  SI,4
WH3:   CMP  SI,76
       JZ   FIN3
       CMP  DI,12
       JZ   REG1
       CMP  DI,13
       JZ   REG2
       JMP  REG3
REG1:  MOV  AL,DS:LINEA_REG1[SI-4]  ;escribimos datos y continuamos
       JMP  EMPI
REG2:  MOV  AL,DS:LINEA_REG2[SI-4]  ;escribimos datos y continuamos
       JMP  EMPI
REG3:  MOV  AL,DS:LINEA_REG3[SI-4]  ;escribimos datos y continuamos
EMPI:  PUSH BX             ;empilamos el atributo
       PUSH AX             ;empilamos el caracter
       PUSH SI             ;empilamos la columna
       PUSH DI             ;empilamos la fila
       CALL ESCR_CAR       ;llamada a subrutina de escritura
       INC  SI        
       JMP  WH3

FIN3:  CMP  DI,14
       JZ   FINFIN
       MOV  SI,4
       INC  DI
       JMP  WH3
       
FINFIN:POP  DI
       POP  SI
       POP  CX
       POP  BX
       POP  AX             ;restaurar registros
       POP  BP             ;restaurar enlace dinamico
       RET
PRESENT1 ENDP

;rutina que escribe la linea de informacin permanente.
PRESENT2 PROC NEAR

       PUSH BP
       MOV  BP,SP                  ;enlace dinamico
       PUSH AX
       PUSH BX
       PUSH SI
       PUSH DI                     ;salvar registros

;borramos las lineas iniciales de reglas del juego
       MOV  BX,03H
       MOV  DI,12
       MOV  SI,1            ;inicializamos el contador de columnas
WH2:   CMP  SI,79
       JZ   SEG             ;si columna=80 => FIN2
       PUSH BX              ;empilamos el atributo
       MOV  AL,DS:LINEA_VACIA[SI]
       PUSH AX              ;empilamos el caracter
       PUSH SI              ;empilamos la columna
       PUSH DI              ;empilamos la fila
       CALL ESCR_CAR        ;llamada asubrutina de escritura
       INC  SI              ;incremantamos la columna
       JMP  WH2
SEG:   INC  DI
       MOV  SI,1
       CMP  DI,16
       JNZ  WH2
       
       MOV  DI,22
       MOV  SI,0
COMP:  MOV  AL,DS:LINEA_HORI[SI] ;escribimos linea horizontal y continuamos
       PUSH BX                   ;empilamos atributo
       PUSH AX                   ;empilamos caracter
       PUSH SI                   ;empilamos la columna
       PUSH DI                   ;empilamos la fila
       CALL ESCR_CAR
       INC  SI
       CMP  SI,80
       JNZ  COMP                 ;si columna=80 => FINAL
       
       MOV  DI,23
       MOV  SI,4
       MOV  BX,0FH
COMP1: MOV  AL,DS:LINEA_INFO[SI-4]
       PUSH BX                   ;empilamos atributo
       PUSH AX                   ;empilamos caracter
       PUSH SI                   ;empilamos la columna
       PUSH DI                   ;empilamos la fila
       CALL ESCR_CAR
       INC  SI
       CMP  SI,76
       JNZ  COMP1

       POP  DI
       POP  SI
       POP  BX
       POP  AX                    ;restaurar registros
       POP  BP                    ;restaurar enlace dinamico
       RET
PRESENT2 ENDP

;Rutina que realiza un bucle de simulacin de espera.
ESPERA PROC NEAR

       PUSH BP
       MOV  BP,SP          ;enlace dinamico
       PUSH CX
       PUSH DX            ;salvar registros
       
       MOV DX,0
BUC1 : MOV CX,0FFFFH
BUC2 : DEC CX
       CMP CX,00H
       JNZ BUC2
       INC DX
       CMP DX,1FH
       JNZ BUC1

       POP  CX
       POP  DX             ;restaurar registros
       POP  BP             ;restaurar enlace dinamico
       RET
ESPERA ENDP

DIB_PELO PROC NEAR   ;rutina que dibuja la pelota en la posicin (i,j).

       PUSH BP
       MOV  BP,SP             ;enlace dinmico
       PUSH AX                ;guardar registros

       MOV  AX,0FH
       PUSH AX                ;empilamos el atributo
       MOV  AL,236
       PUSH AX                ;empilamos el caracter := ''
       MOV  AL,COL_PELO
       PUSH AX                ;empilamos la columna
       MOV  AL,FIL_PELO
       PUSH AX                ;empilamos la fila
       CALL ESCR_CAR          ;llamada a subrutina de escritura
       
       POP  AX                ;restaurar registros
       POP  BP                ;restauramos emlace dinmico

       RET       
DIB_PELO  ENDP

;Rutina que dibuja el muro en pantalla.
DIB_MURO PROC NEAR

       PUSH BP
       MOV  BP,SP          ;enlace dinamico
       PUSH AX
       PUSH BX
       PUSH SI
       PUSH DI            ;salvar registros
       
       MOV  SI,0
       MOV  DI,0          ;inicializamos los ndices
       
COMP8: CMP  SI,8
       JGE  SIMAY
COMP73:CMP  DI,72
       JGE  DIMAY
       MOV  AX,04H
       PUSH AX             ;empilamos atributo
       
       MOV  AX,72
       MUL  SI
       ADD  AX,DI
       MOV  BX,AX
       MOV  AL,DS:M[BX]    ;AX := caracter a empilar
       
       PUSH AX             ;empilamos caracter
       MOV  AX,DI
       ADD  AX,4
       PUSH AX             ;empilamos la columna
       MOV  AX,SI
       INC  AX
       PUSH AX             ;empilamos la fila
       CALL ESCR_CAR
       INC  DI
       JMP  COMP73
       
DIMAY: MOV  DI,0
       INC  SI
       JMP  COMP8

SIMAY: POP  DI
       POP  SI
       POP  BX
       POP  AX             ;restaurar registros
       POP  BP             ;restaurar enlace dinamico
       RET
DIB_MURO ENDP

ESCR_NOM PROC NEAR         ;Subrutina que escribe de la variable NOM, el
       PUSH BP             ;nombre del jugador tecleado.
       MOV  BP,SP          ;enlace dinamico
       PUSH AX
       PUSH SI
       PUSH DI             ;salvar registros

       MOV  DI,23
       MOV  SI,0
WHNOM: CMP  SI,8
       JZ   FINOM          ;si SI=80 => FINOM
       MOV  AX,0CH
       PUSH AX             ;empilamos el atributo
       MOV  AL,DS:NOM[SI]
       PUSH AX             ;empilamos el carcter
       MOV  AX,SI
       ADD  AX,13
       PUSH AX             ;empilamos la columna
       PUSH DI             ;empilamos la fila
       CALL ESCR_CAR       ;llamada a subrutina de escritura
       INC  SI
       JMP  WHNOM

FINOM: POP  DI
       POP  SI
       POP  AX             ;restaurar registros
       POP  BP             ;restaurar enlace dinamico
       RET
ESCR_NOM ENDP

CODIGO ENDS
       END ARKANO2
