; Fichero: DIB_PALA.ASM
; Rutina que dibuja la pala a partir de la fila 19 y de columna indicada
; por la variable POSI_PALA (en el eje X).

TITLE  DIB_PALA


; Rutinas FAR que utiliza DIB_PALA:
EXTRN ESCR_CAR:FAR        ;Rutina que escribe un carcter por pantalla.

; Variables globales que utiliza DIB_PALA:
EXTRN POSI_PALA:BYTE      ;Contiene la actual posisin de la raqueta.
EXTRN LIN1_PALA:BYTE      ;Variables que representan por pantalla
EXTRN LIN2_PALA:BYTE      ;a la raqueta.


CODIGO SEGMENT PUBLIC 'CODIGO'
       ASSUME CS:CODIGO


PUBLIC   DIB_PALA
DIB_PALA PROC FAR

       PUSH BP
       MOV  BP,SP         ;Enlace dinmico.
       PUSH AX
       PUSH SI
       PUSH DI            ;Guardar registros.

       MOV  DI,19         ;Inicializar la fila.
WH1 :  CMP  DI,20
       JG   FIN_FIL

       MOV  SI,0          ;Inicializar la columna.
WH2 :  CMP  SI,10
       JG   FIN_COL

       MOV  AX,0BH
       PUSH AX            ;Empilar el atributo.
       CMP  DI,19
       JZ   LINEA1        ;Saltar a 1 linea de la pala.
       JMP  LINEA2        ;Saltar a 2 linea de la pala.

LINEA1:MOV AL,LIN1_PALA[SI]
       JMP SEGUIR
LINEA2:MOV AL,LIN2_PALA[SI]

SEGUIR:PUSH AX            ;Empilar el caracter.
       MOV  AL,POSI_PALA
       ADD  AX,SI
       PUSH AX            ;Empilar la columna.
       PUSH DI            ;Empilar la fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.
       INC  SI
       JMP  WH2

FIN_COL:INC  DI
       JMP  WH1

FIN_FIL:POP DI
       POP  SI
       POP  AX            ;Restaurar registros.
       POP  BP            ;Restaurar emlace dinmico.
       RET

DIB_PALA  ENDP
CODIGO    ENDS
          END
