; Fichero: DIR_PANT.ASM
; Rutina que averigua el modo de video dejando el resultado en AX
; y en la variable Global DIRPAN.

TITLE DIR_PANT

; Variables globales que utiliza DIR_PANT:
EXTRN DIRPAN:WORD         ;Contiene el modo video del monitor.

CODIGO SEGMENT PUBLIC 'CODIGO'
       ASSUME CS:CODIGO

PUBLIC   DIR_PANT
DIR_PANT PROC FAR

      PUSH BP
      MOV BP,SP           ;Se establece el enlace dinmico.

      XOR AX,AX
      MOV ES,AX
      MOV AL,ES:[449H]    ;Posicin de memoria en la que se mira para
      CMP AL,7            ;ver qu modo de video tiene el ordenador.
      JE  BCERO

      CMP AL,2
      JE  BOCHO
 
      CMP AL,3
      JE  BOCHO
      JMP ERROR
 
BCERO:MOV AX,0B000H       ;Hercules, Monocromo
      JMP FIN
 
BOCHO:MOV AX,0B800H       ;CGA
      JMP FIN
 
ERROR:MOV AX,0H
FIN:  MOV DIRPAN,AX       ;DIRPAN:=modo de video del ordenador.

      POP  BP             ;Restaurar enlace dinmico.
      RET

DIR_PANT  ENDP
CODIGO    ENDS
          END
