; Fichero: ESCR_CAR.ASM
; Rutina que escribe un carcter por pantalla segun los parmetros que
; hay en la pila: ATRIBTUO, CARACTER, COLUMNA y FILA.

TITLE ESCR_CAR

; Parmetros que utiliza ESCR_CAR:
FILA      EQU [BP+6]
COLUMNA   EQU [BP+8]
CARACTER EQU [BP+10]
ATRIBUTO EQU [BP+12]

CODIGO SEGMENT PARA PUBLIC
       ASSUME CS:CODIGO

PUBLIC   ESCR_CAR
ESCR_CAR PROC FAR

       PUSH BP
       MOV  BP,SP         ;Establecer enlace dinmico.
       PUSH AX
       PUSH BX
       PUSH CX            ;Guardar registros.

       MOV  AX,FILA       ;Recoger la fila.
       MOV  CX,80
       MUL  CL            ;AX:=i*80.
       ADD  AX,COLUMNA    ;AX:=(i*80)+j.
       SAL  AX,1          ;AX:=2((i*80)+j).
       MOV  BX,AX
       MOV  AX,CARACTER
       MOV  CX,ATRIBUTO
       MOV  AH,CL
       MOV  ES:[BX],AX    ;Escribe el carcter en la posicin (i,j).

       POP CX
       POP BX
       POP AX             ;Restaurar registros.
       POP BP             ;Restaurar enlace dinnico.
       RET 8
ESCR_CAR ENDP
CODIGO   ENDS
         END
