; Fichero PEGA_PAR.ASM
; Rutina que nos dice si la pelota ha chocado con alguna de las
; paredes del juego.

TITLE PEGA_PAR   

; Rutinas FAR que utiliza  PEGA_PAR:
EXTRN ESCR_CAR:FAR    ;Rutina que escribe un carcter por pantalla.
EXTRN LEECAR_E:FAR    ;Rutina que lee un carcter del teclado.
EXTRN SONIDO:FAR      ;Rutina que activa el altavoz del PC.

; Variables globales que utiliza PEGA_PAR:
EXTRN FIL_PELO:BYTE      ;Variables que contienen la posicin (i,j) de
EXTRN COL_PELO:BYTE      ;la pelota.
EXTRN ZONA_PANTALLA:BYTE ;Codifica el lugar en que sen encuentra la
                         ;pelota dentro de la pantalla.

CODIGO SEGMENT PUBLIC 'CODIGO'
       ASSUME CS:CODIGO

PUBLIC   PEGA_PAR
PEGA_PAR PROC FAR

       PUSH BP
       MOV  BP,SP         ;Enlace dinmico.
       PUSH AX            ;Guardar registros.

       CMP  COL_PELO,4
       JNZ  FILA_00
       CMP  FIL_PELO,18
       JNZ  FILA_0
       MOV  ZONA_PANTALLA,4  ;Esquina inferior izquierda.
       JMP  FINAL
       
FILA_0:CMP  FIL_PELO,1
       JNZ  SINO_1
       MOV  ZONA_PANTALLA,5  ;Esquina superior izquierda.
       MOV  AX,3900
       PUSH AX               ;Empilo parmetro frecuencia.
       CALL SONIDO           ;Emitir sonido.
       JMP  FINAL
       
SINO_1:MOV  ZONA_PANTALLA,1  ;Pared izquierda.
       MOV  AX,3900
       PUSH AX               ;Empilo parmetro frecuencia.
       CALL SONIDO           ;Emitir sonido.
       JMP  FINAL

FILA_00:CMP FIL_PELO,1
       JNZ  COL_75
       CMP  COL_PELO,75
       JNZ  SINO_2
       MOV  ZONA_PANTALLA,6  ;Esquina superior derecha.
       MOV  AX,3900
       PUSH AX               ;Empilo parmetro frecuencia.
       CALL SONIDO           ;Emitir sonido.
       JMP  FINAL
       
SINO_2:MOV  ZONA_PANTALLA,2  ;Pared superior.
       MOV  AX,3900
       PUSH AX               ;Empilo parmetro frecuencia.
       CALL SONIDO           ;Emitir sonido.
       JMP  FINAL

COL_75:CMP  COL_PELO,75
       JNZ  SINO_FINAL
       CMP  FIL_PELO,18
       JNZ  SINO_3
       MOV  ZONA_PANTALLA,7  ;Esquina inferior derecha.
       JMP  FINAL
       
SINO_3:MOV  ZONA_PANTALLA,3  ;Pared derecha.
       MOV  AX,3900
       PUSH AX               ;Empilo parmetro frecuencia.
       CALL SONIDO           ;Emitir sonido.
       JMP  FINAL

SINO_FINAL:MOV ZONA_PANTALLA,0 ;No toca ninguna pared.

FINAL: POP  AX            ;Restaurar registros.
       POP  BP            ;Restaurar enlace dinmico.
       RET
PEGA_PAR ENDP

CODIGO  ENDS  
        END
