; Fichero SONIDO.ASM
; Rutina que habilita el altavoz del PC para prodicir sonidos mediante
; seales de onda cuadrada.

TITLE SONIDO

; Parmetros que utiliza SONIDO:
FRECUENCIA EQU [BP+6]

CODIGO SEGMENT PUBLIC 'CODIGO'
       ASSUME CS:CODIGO

PUBLIC SONIDO
SONIDO PROC FAR

       PUSH BP
       MOV  BP,SP         ;Enlace dinmico.
       PUSH AX            ;Salvar registros.
       
; Para definir la frecuencia
      MOV  AL,0B6H
      OUT  43H,AL
      MOV  AX,FRECUENCIA
      OUT  42H,AL
      MOV  AL,AH
      OUT  42H,AL

; Con esto se actica el altavoz.
      IN   AL,61H
      OR   AL,00000011B
      OUT  61H,AL

       POP  AX            ;Restaurar registros.
       MOV  SP,BP
       POP  BP            ;Restaurar enlace dinmico.
       RET  2             ;Retorna al programa llamador eliminando
                          ;parmetro.
SONIDO  ENDP
CODIGO  ENDS
        END
