TITLE PANTALLA

PILA SEGMENT PARA STACK 'STACK'
     DB 64 DUP ('XXXXXX')
PILA ENDS

DATOS SEGMENT PARA PUBLIC 'DATA'
     DIRPAN   DW  ?
     FRASE    DB  'HASTA CUANDO DURARAN LAS VACACIONES DE NAVIDAD 1996'
     FILA     DW  24
     COLUMNA  DW  1
     ATRIBUTO DB  1Fh   
DATOS ENDS

CODIGO SEGMENT PARA PUBLIC 'CODE'
     ASSUME CS:CODIGO, SS:PILA, DS:DATOS
     
     
PRINCIPAL PROC FAR

          PUSH DS
          SUB AX,AX
          PUSH AX
          
          MOV AX,DATOS          ;actualizacin de DS
          MOV DS,AX
          
          CALL DIR_PAN
          MOV ES,DIRPAN
          
          LEA AX,FILA            ;@ FINAL DE FRASE
          LEA BX,FRASE           ;@ COMIENZO DE FRASE
          
          PUSH BX
          PUSH AX
          MOV CX,COLUMNA
          PUSH CX
          MOV CX,FILA
          PUSH CX
          MOV CX,WORD PTR ATRIBUTO
          PUSH CX
          CALL ESCRIMEM
          RET
          
   PRINCIPAL ENDP

;->>> ESCRIMEM <<<----------------------------------------------------
;
;   Rutina para escribir un mensaje directamente en la memora de video.
;
; Parmetros:
;     @ comienzo del string a escribir
;     @ final del string
;     columna
;     fila
;     atributo 
   
   ESCRIMEM PROC NEAR
          
          PUSH BP
          MOV BP,SP
          PUSH AX
          PUSH BX
          PUSH CX
          MOV AX,10[BP]          ;AX <- @FINAL DEL STRING
          MOV BX,12[BP]          ;BX <- @COMIENZO DEL STRING
   BUCLE: CMP BX,AX
          JGE FINSTR
          MOV CL,[BX]            ;CL <- CARACTER ACTUAL
          MOV CH,4[BP]           ;CH <- ATRIBUTO
          PUSH CX
          MOV CX,8[BP]           ;CX <- COLUMNA
          PUSH CX
          MOV CX,6[BP]           ;CX <- FILA 
          PUSH CX
          CALL ESCRICAR
          INC BX                 ;PASAR AL SIGUIENTE CARACTER   
          INC WORD PTR 8[BP]     ;PASAR A LA SIGUIENTE COLUMNA
          CMP COLUMNA,79
          JGE INCY
          JMP BUCLE
    INCY: INC FILA               ;PASAR A LA SIGUIENTE FILA
          JMP BUCLE
  FINSTR: POP CX
          POP BX
          POP AX
          MOV SP,BP
          POP BP
          RET 10
          
   ESCRIMEM ENDP


   
;-->>> ESCRICAR <<<-----------------------------------------------------
;
;     Rutina para escribir un carcter directamente a memora de video.
;
; Parmetros:
;     atributo | carcter (WORD)
;     columna
;     fila
   
   ESCRICAR PROC NEAR
          
          PUSH BP
          MOV BP,SP 
          PUSH AX
          PUSH BX
          PUSH CX
          PUSH DX
          MOV AX,4[BP]          ;AX <- FILA
          MOV CX,80
          MUL CX                ;AX <- FILA*80
          ADD AX,6[BP]          ;AX <- FILA*80 + COLUMNA
          SHL AX,1              ;AX <- 2*(FILA*80 + COLUMNA)
          MOV BX,AX             ;BX <- @MEMORIA DE PANTALLA
          MOV AX,8[BP]          ;AX <- ATRIBUTO | CARACTER
          MOV ES:[BX],AX        ;ESCRIBIR ATRIBUTO | CARACTER
          POP DX
          POP CX
          POP BX
          POP AX
          MOV SP,BP
          POP BP
          RET 6
          
   ESCRICAR ENDP
   
   
   DIR_PAN PROC NEAR
   
          PUSH AX
          PUSH ES
          XOR AX,AX
          MOV ES,AX
          MOV AL, ES:[449H]
          CMP AL,7
          JE BCERO
          CMP AL,2
          JE BOCHO
          CMP AL,3
          JE BOCHO
          JMP ERROR
   BCERO: MOV DIRPAN,0B000H
          JMP FINAL
   BOCHO: MOV DIRPAN,0B800H
          JMP FINAL
   ERROR: MOV DIRPAN,0H
   FINAL: POP ES
          POP AX
          RET
   
   DIR_PAN ENDP
   
CODIGO ENDS

     END PRINCIPAL                 