 TITLE programa


 PILA segment para public stack 'stack'   ; PARA -> @segmento mod 16=0
       DB 64 DUP ('PILA...')              ; PILA 64 bytes  DB FFh DUP(0)
 PILA ends

 DATOS segment para public 'DATA'
        DIRPAN   dw  ?
        FRASE    db  'CUANDO EMPEZARAN LAS VACACIONES?'
        FILA     dw  20
        COLUMNA  dw  50
 DATOS ends                               ; valor puede ser ?

 CODIGO segment para public 'code'
     assume CS:codigo, DS:datos, SS:pila



   PRINCIPAL proc  FAR

             push  DS                   ; para volver al DOS
             sub   AX, AX
             push  AX
             mov   AX, DATOS
             mov   DS, AX


             call  DIR_PAN
             mov   ES, DIRPAN

             call  WRITEALL

             ret             

   PRINCIPAL endp



   DIR_PAN proc  NEAR

           push  AX
           push  ES
           xor   AX, AX
           mov   ES, AX
           mov   AL, ES:[449h]
           cmp   AL, 7
           je    BCERO
           cmp   AL, 2
           je    BOCHO
           cmp   AL, 3
           je    BOCHO
           jmp   ERROR

   BCERO:  mov   DIRPAN, 0B000h
           jmp   FINAL

   BOCHO:  mov   DIRPAN, 0B800h
           jmp   FINAL

   ERROR:  mov   DIRPAN, 0h

   FINAL:  pop   ES
           pop   AX
           ret

   DIR_PAN endp




   WRITEALL proc  NEAR

            push  BP
            mov   BP, SP

            push  BX
            push  DX
            push  DI
            push  SI

            lea   BX, FRASE
            lea   SI, FILA
            lea   DI, COLUMNA

   BUCLE:   cmp   BX, SI
            je    FIN
            mov   DX, [BX]
            push  DX          ; empila CHAR
            mov   DX, 7
            push  DX          ; empila ATTR
            mov   DX, [SI]
            push  DX          ; empila FILA
            mov   DX, [DI]
            push  DX          ; empila COLUMNA

            call  IMPCHAR

            inc   BX                ; inc @caracter a imprimir
            inc   WORD PTR [DI]     ; inc COLUMNA
            cmp   WORD PTR [DI], 79
            jg    INCFILA
            jmp   BUCLE

   INCFILA: inc   WORD PTR [SI]     ; inc FILA
            mov   WORD PTR [DI], 0  ; COLUMNA:=0
            jmp   BUCLE

            pop   SI
            pop   DI
            pop   DX
            pop   BX

            pop   BP

   FIN:     ret

   WRITEALL endp



   IMPCHAR proc  NEAR            ;            regs
                                 ;            BPfrase <= BP impchar
            push  BP             ;      2[BP] COLUMNA
            mov   BP, SP         ;      4[BP] FILA
                                 ;      6[BP] ATTR
            push  AX             ;      8[BP] CHAR
            push  BX             ;            regs
            push  CX             ;            BPmain

            mov   AX, 4[BP]      ; AX:=FILA
            mov   CX, 80
            mul   CX             ; AX:=FILA*80
            mov   CX, 2[BP]      ; CX:=COLUMNA
            add   AX, CX         ; AX:=(FILA*80) + COLUMNA
            mov   CX, 2
            mul   CX             ; AX:=((FILA*80) + COLUMNA) * 2
            mov   BX, AX         ; BX:=((FILA*80) + COLUMNA) * 2

            mov   CX, 8[BP]      ; CX:=CHAR
            mov   ES:[BX], CX    ;

            mov   CX, 6[BP]      ; CX:=ATTR
            mov   ES:[BX+1], CX  ;

            pop   CX
            pop   BX
            pop   AX

            pop   BP

            ret   8

   IMPCHAR endp



 CODIGO ends
 end PRINCIPAL
