 TITLE ARKANO2

; PROGRAMA PRINCIPAL

        EXTRN BLANCOS: FAR	; PROCEDIMIENTOS Y VARIABLES EXTERNAS  
        EXTRN DIRPANT: FAR	; UTILIZADAS
        EXTRN MENSAJE: FAR
        EXTRN ESCR_CAR: FAR
        EXTRN LEETEC_E: FAR
        EXTRN PR: FAR
        EXTRN PREJUE: FAR
        PUBLIC DIRPAN
        PUBLIC JUGADOR
        PUBLIC TABLA
        
   PILA SEGMENT PARA STACK 'PILA'	; DECLARACION DEL SEGMENTO DE PILA
        DB 64 DUP ('PILA....')
   PILA ENDS

   DATOS SEGMENT PARA PUBLIC 'DATOS'	; DECLARACION DE VARIABLES

; VARIABLE TABLA QUE UTILIZAMOS PARA TRADUCIR EL CODIGO DE RASTREO LEIDO

     TABLA   DB 27,'1234567890-='		
             DB 8,9,'QWERTYUIOP[]',13,' '
             DB 'ASDFGHJKL;',' '
             DB '<-XCVBNM,.-',' '
             DB ' ',' '
             DB ' ',13 DUP (' ')     
             DB '+98-456+1230,'
      	 DIRPAN DW ?		; VARIABLE QUE UTILIZAMOS PARA GUARDAR LA
         			; DIRECCION BASE DE LA PANTALLA
	 PALA DB ''
         PELOTA DB 'o'
         JUGADOR DB '      '
    DATOS ENDS

   CODIGO SEGMENT PARA PUBLIC 'CODIGO'
        ASSUME CS:CODIGO, DS:DATOS, SS:PILA

   ARKANO2 PROC FAR
           PUSH DS
           XOR  AX, AX          ; PREPARAMOS RETORNO A DOS
           PUSH AX
           
	   MOV  AX, DATOS	; DIRECCIONAMOS A 'DS' NUESTRO SEGMENTO DE 
           MOV  DS, AX		; DATOS
       
           CALL DIRPANT  	; LLAMADA AL PROCEDIMIENTO QUE NOS DARA LA
           MOV  ES, DIRPAN	; DIRECCION BASE DE LA PANTALLA, QUE GUARDAMOS
          			; EN EL REGISTRO 'ES' 
           
	   CALL BLANCOS		; LIMPIAMOS LA PANTALLA

           CALL PR		; PANTALLA DE PRESENTACION DEL JUEGO
           
           CALL LEETEC_E	; LEEMOS EL NOMBRE POR ENCUESTA 
                      

           CALL BLANCOS		; LIMPIAMOS DE NUEVO LA PANTALLA
           
	   MOV  AX, OFFSET JUGADOR
           PUSH AX
           CALL PREJUE		; ESCRIBIMOS EL ESCENARIO DEL JUEGO
             
           MOV  AX, OFFSET PELOTA - OFFSET PALA
           PUSH AX
           MOV  AX, OFFSET PALA
           PUSH AX
           MOV  AX, 37
           PUSH AX		; UTILIZAMOS 'MENSAJE' Y 'ESCR_CAR' PARA
           MOV  AX, 21		; DIBUJAR LA PALA Y LA PELOTA
           PUSH AX
           CALL MENSAJE
           MOV  AX, 07h
           PUSH AX
           MOV  AL, PELOTA
           PUSH AX
           MOV  AX, 40
           PUSH AX
           MOV  AX, 20
           PUSH AX
           CALL ESCR_CAR
          
	   RET			; DEVOLVEMOS EL CONTROL AL S.O
             
     ARKANO2 ENDP
      CODIGO ENDS
    
             END ARKANO2
