TITLE LAD_PEL

; PROCEDIMIENTO QUE CONTROLA SI LA PELOTA PEGA EN ALGUN LADRILLO O NO

        EXTRN MENSAJE: FAR
        EXTRN ESCR_CAR: FAR
        EXTRN CAR_MEM: FAR
        EXTRN N_PUNTOS: WORD
        EXTRN MOVI: BYTE
        EXTRN FILA_AUX: WORD
        EXTRN COL_AUX: WORD
        EXTRN FILA_P: WORD
        EXTRN COLUMNA_P: WORD
        EXTRN MOV_VERT: WORD
        EXTRN MOV_HORIZ: WORD
        EXTRN LAD_BLANCOS: BYTE
        EXTRN N_PUNTOS1: WORD
        EXTRN N_PUNTOS2: WORD
        EXTRN BIP: FAR
        EXTRN ACT_PTOS: FAR  
                         
        CODIGO SEGMENT PARA PUBLIC 'CODIGO'
                ASSUME CS:CODIGO

        PUBLIC LAD_PEL

        LAD_PEL PROC FAR

                PUSH BP                 ;ENLACE DINAMICO
                MOV  BP, SP

                PUSH CX
                PUSH AX                 ; SALVAMOS EL ESTADO

                CMP  MOVI, 1
                JE   FIN_13
                
                SUB  SP, 2              ; RESERVAMOS UN ESPACIO EN LA PILA
                MOV  AX, FILA_P
                DEC  AX
                PUSH AX
                MOV  AX, COLUMNA_P
                PUSH AX
                CALL CAR_MEM
                POP  AX                 ; GUARDAMOS EN 'AX' EL CARACTER DE 
                                        ; MEMORIA EN ESA POSICION

                CMP  AL, 0DBH
                JE   ARRIBA1
                CMP  AL, 0B2H
                JE   ARRIBA1

                SUB  SP, 2              ; RESERVAMOS UN ESPACIO EN LA PILA
                MOV  AX, FILA_P
                INC  AX
                PUSH AX
                MOV  AX, COLUMNA_P
                PUSH AX
                CALL CAR_MEM
                POP  AX     

                CMP  AL, 0DBH
                JE   ABAJO1
                CMP  AL, 0B2H
                JE   ABAJO1
                     
                JMP  SEGUIR
                
        FIN_13: JMP  FIN_12
        
        ARRIBA1:JMP  ARRIBA
         
        SEGUIR: SUB  SP, 2              ; RESERVAMOS UN ESPACIO EN LA PILA
                MOV  AX, FILA_P
                PUSH AX
                MOV  AX, COLUMNA_P
                INC  AX
                PUSH AX
                CALL CAR_MEM
                POP  AX  
                
                CMP  AL, 0DBH
                JE   DERECHA1
                CMP  AL, 0B2H
                JE   DERECHA1           
      
                SUB  SP, 2              ; RESERVAMOS UN ESPACIO EN LA PILA
                MOV  AX, FILA_P
                PUSH AX
                MOV  AX, COLUMNA_P
                DEC  AX
                PUSH AX
                CALL CAR_MEM
                POP  AX    
                    
                CMP  AL, 0DBH
                JE   IZQUIERDA1
                CMP  AL, 0B2H
                JE   IZQUIERDA1  

                MOV  AX, FILA_P
                ADD  AX, MOV_VERT
                MOV  FILA_AUX, AX
                MOV  AX, COLUMNA_P
                ADD  AX, MOV_HORIZ
                MOV  COL_AUX, AX

                SUB  SP, 2
                MOV  AX, FILA_AUX
                PUSH AX
                MOV  AX, COL_AUX
                PUSH AX
                CALL CAR_MEM
                POP  AX
                CMP  AL, 0DBH
                JE   ESQ_LAD0
                CMP  AL, 0B2H
                JE   ESQ_LAD0

                JMP  FIN_12
                                
        ABAJO1: JMP ABAJO2
        
        FIN_12: JMP FIN_1_2

        DERECHA1: JMP DERECHA2

       IZQUIERDA1: JMP IZQUIERDA2

        ARRIBA: SUB  SP, 2              ; RESERVAMOS UN ESPACIO EN LA PILA
                MOV  AX, FILA_P
                PUSH AX
                MOV  AX, COLUMNA_P
                INC  AX
                PUSH AX
                CALL CAR_MEM
                POP  AX   

                CMP  AL, 0DBH
                JE   ARR_DER0
                CMP  AL, 0B2H
                JE   ARR_DER0
                
                SUB  SP, 2              ; RESERVAMOS UN ESPACIO EN LA PILA
                MOV  AX, FILA_P
                PUSH AX
                MOV  AX, COLUMNA_P
                DEC  AX
                PUSH AX
                CALL CAR_MEM
                POP  AX        
                CMP  AL, 0DBH
                JE   ARR_IZQ0
                CMP  AL, 0B2H
                JE   ARR_IZQ0 

                MOV  AX, COLUMNA_P
                TEST AL, 07h
                JZ   ULTIMO_LAD

                MOV  AX, FILA_P
                DEC  AX
                PUSH AX
                MOV  AX, COLUMNA_P
                AND  AX, 0F8H
                INC  AX
                PUSH AX
                CALL BORRAR_LADRILLO

                MOV  AX, FILA_P
                DEC  AX
                PUSH AX
                CALL ACT_PTOS
                 
                MOV AX, MOV_VERT
                MOV CX, -1
                MUL CX
                MOV MOV_VERT, AX
                JMP ACTUALIZAR

      ARR_DER0: JMP ARR_DER

      ARR_IZQ0: JMP ARR_IZQ

      ESQ_LAD0: JMP ESQ_LAD1

    ULTIMO_LAD: MOV  AX, FILA_P
                DEC  AX
                PUSH AX
                 
                MOV  AX, COLUMNA_P
                SUB  AX,7
                PUSH AX
                CALL BORRAR_LADRILLO

                MOV  AX, FILA_P
                DEC  AX
                PUSH AX
                CALL ACT_PTOS
                 
                MOV AX, MOV_VERT
                MOV CX, -1
                MUL CX
                MOV MOV_VERT, AX
                JMP ACTUALIZAR

       ABAJO2:  JMP ABAJO 
      ESQ_LAD1: JMP ESQ_LAD 
      IZQUIERDA2: JMP IZQUIERDA3

    FIN_1_2:    JMP FIN_2_2

     ARR_DER:   MOV  AX, FILA_P
                INC  AX
                PUSH AX
                MOV  AX, COLUMNA_P
                SUB  AX, 7
                PUSH AX
                CALL BORRAR_LADRILLO

                MOV  AX, FILA_P
                INC  AX
                PUSH AX
                CALL ACT_PTOS
                
                MOV  AX, FILA_P
                DEC  AX
                PUSH AX
                MOV  AX, COLUMNA_P
                INC  AX
                PUSH AX
                CALL BORRAR_LADRILLO

                MOV  AX, FILA_P
                DEC  AX
                PUSH AX
                CALL ACT_PTOS
      
                MOV  AX, MOV_VERT
                MOV  CX, -1
                MUL  CX
                MOV  MOV_VERT, AX
                MOV  AX, MOV_HORIZ
                MOV  CX, -1
                MUL  CX
                MOV  MOV_HORIZ, AX
                JMP  ACTUALIZAR          
                DERECHA2: JMP DERECHA

       ARR_IZQ: MOV  AX, FILA_P
                DEC  AX
                PUSH AX
                MOV  AX, COLUMNA_P
                PUSH AX
                CALL BORRAR_LADRILLO

                MOV  AX, FILA_P
                DEC  AX
                PUSH AX
                CALL ACT_PTOS
        
                MOV  AX, FILA_P
                INC  AX
                PUSH AX
                MOV  AX, COLUMNA_P
                SUB  AX, 8
                PUSH AX
                CALL BORRAR_LADRILLO

                MOV  AX, FILA_P
                INC  AX
                PUSH AX
                CALL ACT_PTOS
      
                MOV  AX, MOV_VERT
                MOV  CX, -1
                MUL  CX
                MOV  MOV_VERT, AX
                MOV  AX, MOV_HORIZ
                MOV  CX, -1
                MUL  CX
                MOV  MOV_HORIZ, AX
                JMP  ACTUALIZAR 
      
    IZQUIERDA3: JMP IZQUIERDA4

      ABAJO:    SUB  SP, 2              ; RESERVAMOS UN ESPACIO EN LA PILA
                MOV  AX, FILA_P
                PUSH AX
                MOV  AX, COLUMNA_P
                INC  AX
                PUSH AX
                CALL CAR_MEM
                POP  AX   

                CMP  AX, 0DBH
                JE   ABJ_DER0
                CMP  AX, 0B2H
                JE   ABJ_DER0

                SUB  SP, 2              ; RESERVAMOS UN ESPACIO EN LA PILA
                MOV  AX, FILA_P
                PUSH AX
                MOV  AX, COLUMNA_P
                DEC  AX
                PUSH AX
                CALL CAR_MEM
                POP  AX    
                CMP  AX, 0DBH
                JE   ABJ_IZQ0
                CMP  AX, 0B2H
                JE   ABJ_IZQ0 

                MOV  AX, COLUMNA_P
                TEST AL, 07H
                JZ   ULTIMO_LAD2
              
                MOV  AX, FILA_P
                ADD  AX, 2
                PUSH AX
                MOV  AX, COLUMNA_P
                AND  AX, 0F8H
                INC  AX
                PUSH AX
                CALL BORRAR_LADRILLO

                MOV  AX, FILA_P
                ADD  AX, 2
                PUSH AX
                CALL ACT_PTOS 

                MOV AX, MOV_VERT
                MOV CX, -1
                MUL CX
                MOV MOV_VERT, AX
                JMP ACTUALIZAR 
    ABJ_DER0:   JMP ABJ_DER
    ULTIMO_LAD2: MOV  AX, FILA_P
                 ADD  AX,2
                 PUSH AX
                 
                MOV  AX, COLUMNA_P
                SUB  AX,7
                PUSH AX
                CALL BORRAR_LADRILLO

                MOV  AX, FILA_P
                ADD  AX, 2
                PUSH AX
                CALL ACT_PTOS
                 
                MOV AX, MOV_VERT
                MOV CX, -1
                MUL CX
                MOV MOV_VERT, AX
                JMP ACTUALIZAR

          ABJ_IZQ0: JMP ABJ_IZQ

      ABJ_DER:  MOV  AX, FILA_P
                PUSH AX
                MOV  AX, COLUMNA_P
                INC  AX
                PUSH AX
                CALL BORRAR_LADRILLO

                MOV  AX, FILA_P
                PUSH AX
                CALL ACT_PTOS
        
                MOV  AX, FILA_P
                ADD  AX,2
                PUSH AX
                MOV  AX, COLUMNA_P
                SUB  AX, 7
                PUSH AX
                CALL BORRAR_LADRILLO

                MOV  AX, FILA_P
                ADD  AX, 2
                PUSH AX
                CALL ACT_PTOS
      
                JMP  ACT_MOV
                
                JMP  ACTUALIZAR  

       IZQUIERDA4: JMP IZQUIERDA

       ABJ_IZQ: MOV  AX, FILA_P
                PUSH AX
                MOV  AX, COLUMNA_P
                SUB  AX, 8
                PUSH AX
                CALL BORRAR_LADRILLO

                MOV  AX, FILA_P
                PUSH AX
                CALL ACT_PTOS
        
                MOV  AX, FILA_P
                ADD  AX,2
                PUSH AX
                MOV  AX, COLUMNA_P
                PUSH AX
                CALL BORRAR_LADRILLO

                MOV  AX, FILA_P
                ADD  AX, 2
                PUSH AX
                CALL ACT_PTOS
      
                MOV  AX, MOV_VERT
                MOV  CX, -1
                MUL  CX
                MOV  MOV_VERT, AX
                MOV  AX, MOV_HORIZ
                MOV  CX, -1
                MUL  CX
                MOV  MOV_HORIZ, AX
                JMP  ACTUALIZAR 

     IZQUIERDA: MOV  AX, MOV_HORIZ
                CMP  AX, 0
                JE   AUX_ACT 
                
                MOV  AX, FILA_P
                TEST AL, 01H
                JZ   PAR
                MOV  AX, FILA_P
                INC  AX
                MOV  CX, AX
                PUSH AX
                JMP  IMPAR
          PAR:  MOV  AX, FILA_P
                MOV  CX, AX
                PUSH AX
        IMPAR:  MOV  AX, COLUMNA_P
                SUB  AX, 8
                PUSH AX 
                CALL BORRAR_LADRILLO

                MOV  AX, CX
                PUSH AX
                CALL ACT_PTOS
                 
                MOV  AX, MOV_HORIZ
                MOV  CX, -1
                MUL  CX
                MOV  MOV_HORIZ, AX
       AUX_ACT: JMP  ACTUALIZAR     
        
     DERECHA:   MOV  AX, MOV_HORIZ
                CMP  AX, 0
                JE   AUX_ACT1
                MOV  AX, FILA_P
                TEST AL, 01H
                JZ   PAR_D
                MOV  AX, FILA_P
                INC  AX
                MOV  CX, AX
                PUSH AX
                JMP  IMPAR_D
          PAR_D:MOV  CX, AX
                PUSH AX
        IMPAR_D:MOV  AX, COLUMNA_P
                INC  AX
                PUSH AX 
                CALL BORRAR_LADRILLO

                MOV  AX, CX
                PUSH AX
                CALL ACT_PTOS
                
                MOV  AX, MOV_HORIZ
                MOV  CX, -1
                MUL  CX
                MOV  MOV_HORIZ, AX
      AUX_ACT1: JMP  ACTUALIZAR

       ESQ_LAD: MOV  AX, COLUMNA_P
                TEST AL, 01H
                JZ   PAR_E_L
                MOV  AX, MOV_VERT
                CMP  AX, 1
                JE   ESQ_D_A
                MOV  AX, FILA_P
                DEC  AX
                MOV  CX, AX
                PUSH AX
                JMP  IMP_E_L
       ESQ_D_A: MOV  AX, FILA_P
                ADD  AX, 2
                MOV  CX, AX
                PUSH AX
       IMP_E_L: MOV  AX, COLUMNA_P
                SUB  AX, 8
                PUSH AX
                CALL BORRAR_LADRILLO

                MOV  AX, CX
                PUSH AX
                CALL ACT_PTOS
                
                JMP  ACT_MOV

       PAR_E_L: MOV  AX, MOV_VERT
                CMP  AX, 1
                JE   ESQ_I_A
                MOV  AX, FILA_P
                DEC  AX
                MOV  CX, AX
                PUSH AX
                JMP  IM_L
       ESQ_I_A: MOV  AX, FILA_P
                ADD  AX, 2
                MOV  CX, AX
                PUSH AX
          IM_L: MOV  AX, COLUMNA_P
                INC  AX
                PUSH AX
                CALL BORRAR_LADRILLO

                MOV  AX, CX
                PUSH AX
                CALL ACT_PTOS 
               
       ACT_MOV: MOV  AX, MOV_VERT
                MOV  CX, -1
                MUL  CX
                MOV  MOV_VERT, AX
                MOV  AX, MOV_HORIZ
                MOV  CX, -1
                MUL  CX
                MOV  MOV_HORIZ, AX
                JMP  ACTUALIZAR
       
       FIN_2_2: JMP  FIN
 
   ACTUALIZAR:  MOV  AX, 07h               ; BORRAMOS LA PELOTA
                PUSH AX
                MOV  AL, ' '
                PUSH AX
                MOV  AX, COLUMNA_P
                PUSH AX
                MOV  AX, FILA_P
                PUSH AX
                CALL ESCR_CAR
           
                MOV  AX, 07h
                PUSH AX
                MOV  AL, 'o'
                PUSH AX
                MOV  AX, COLUMNA_P
                ADD  AX, MOV_HORIZ
                MOV  COLUMNA_P, AX
                MOV  AX, COLUMNA_P
                PUSH AX
                MOV  AX, FILA_P
                ADD  AX, MOV_VERT
                MOV  FILA_P, AX
                MOV  AX, FILA_P
                PUSH AX
                CALL ESCR_CAR
                
                CALL BIP
                MOV  N_PUNTOS, 0
                
                MOV  MOVI, 1

         FIN:   POP  AX                 ; RESTAURAMOS EL ESTADO
                POP  CX
                POP  BP
         
                RET                     ; DEVOLVEMOS EL CONTROL

        LAD_PEL ENDP

  BORRAR_LADRILLO PROC NEAR
  
                PUSH BP
                MOV  BP,SP
               
                PUSH AX
                
                MOV  AX, 8
                PUSH AX
                MOV  AX,OFFSET LAD_BLANCOS
                PUSH AX
                MOV  AX, SS:4[BP]
                PUSH AX
                MOV  AX, SS:6[BP]
                PUSH AX
                CALL MENSAJE
    
                MOV  AX, 8
                PUSH AX
                MOV  AX,OFFSET LAD_BLANCOS
                PUSH AX
                MOV  AX, SS:4[BP]
                PUSH AX
                MOV  AX, SS:6[BP]
                DEC  AX
                PUSH AX
                CALL MENSAJE

                POP  AX
                POP  BP
              
                RET  4
  BORRAR_LADRILLO ENDP

         CODIGO ENDS
                END  
