 TITLE LEECAR_I

; PROCEDIMIENTO QUE GESTIONA LA LECTURA , POR INTERRUPCION DE LA TECLA 
; PULSADA 


	EXTRN TABLA: BYTE       ; INSTANCIAMOS COMO EXTERNAS LAS RUTINAS
	EXTRN MENSAJE: FAR      ; QUE VAMOS A UTILIZAR
	EXTRN POSICION_PALA: BYTE
			
      DATOS SEGMENT PARA PUBLIC 'DATOS' ; DECLARACION DE VARIABLES

	 PALA DB ''
	 BLANCOS DB '                                                                        '      
	 LONG_MEN DB ?

      DATOS ENDS

      CODIGO SEGMENT PARA PUBLIC 'CODIGO'
	    ASSUME CS:CODIGO

      PUBLIC LEECAR_I

 LEECAR_I PROC FAR

	 PUSH CX                ; SALVAMOS EL ESTADO
	 PUSH DS
	 PUSH BX
	 CLI                    ; INHIBIMOS LAS INTERRUPCIONES
	 MOV  BX, DATOS         ; ESTABLECEMOS EL SEGMENTO DE DATOS DE LA 
	 MOV  DS, BX            ; PROPIA SUBRUTINA

	 IN   AL, 60h           ; CARGAMOS EL REGISTRO DE CONTROL Y 
	 XOR  AH, Ah            ; CONTROLAMOS SI ES UN 'BREAK' O UN 'MAKE'
	 TEST AL, 80h           
	 JNZ  FIN_LEC_1
	 LEA  BX, TABLA         ; TRADUCIMOS EL CARACTER A ASCII
	 DEC  AL                ;
	 XLAT                   ;

  WHILE: CMP  AL, 46h           ; NOS ASEGURAMOS DE QUE NO ES UNA 'F'
	 JE   FIN_WHILE_1
	 MOV  BX, OFFSET LONG_MEN - OFFSET BLANCOS
	 PUSH BX
	 MOV  BX, OFFSET BLANCOS
	 PUSH BX
	 MOV  BX, 1
	 PUSH BX
	 MOV  BX, 21
	 PUSH BX
	 CALL MENSAJE           ; BORRAMOS TODA LA FILA DONDE ESTA COLOCADA
				; LA PALA PARA LUEGO VOLVER A DIBUJAR LA PALA
				; EN LA POSICION ADECUADA SEGUN EL MOVIMIENTO
	 
  
  IF_O:   CMP  AL, 4Fh          ; SI ES UNA 'O' NOS DESPLAZAMOS UNA POSICION
				; A LA IZDA. SI ES POSIBLE
	  JNE  END_IF_O
	  CMP  POSICION_PALA, 1 ; SI ES UN 1 LA POSICON DE LA PALA NO SE PUEDE
				; MOVER LA PALA Y NO TENEMOS EN CUENTA EL 
				; MOVIMIENTO 
	  JE   END_IF_O
	  CMP  POSICION_PALA,2
	  JNE  NORMAL
	  MOV  BL, POSICION_PALA
	  SUB  BL, 1
	  MOV POSICION_PALA, BL 
	  JMP END_IF_O
  FIN_LEC_1: JMP FIN_LEC
  FIN_WHILE_1: JMP FIN_WHILE
  NORMAL: MOV  BL, POSICION_PALA
	  SUB  BL, 2            ; DECREMENTAMOS LA POSICION DE LA PALA PORQUE 
				; EL MOVIMIENTO A LA IZQUIERDA HA SIDO ACEPTADA
	  MOV  POSICION_PALA, BL
 END_IF_O:CMP  AL, 50h          ; LO MISMO HACIA LA DERECHA
	  JNE  END_IF_P
	  CMP  POSICION_PALA, 66
	  JE   END_IF_P
	  CMP  POSICION_PALA, 65
	  JNE  NORMAL_P
	  MOV  BL, POSICION_PALA
	  INC  BL 
	  MOV  POSICION_PALA, BL
	  JMP  END_IF_P
 NORMAL_P:MOV  BL, POSICION_PALA
	  ADD  BL,2               ; EN ESTE CASO INCREMENTAMOS LA POSICION DE LA
				; PALA PORQUE EL MOVIMIENTO ES A LA DERECHA
	  MOV  POSICION_PALA, BL
 END_IF_P:MOV  BX, OFFSET BLANCOS - OFFSET PALA
	  PUSH BX
	  MOV  BX, OFFSET PALA
	  PUSH BX               ; ESCRIBIMOS LA PALA EN LA PANTALLA, EN LA 
	  MOV  BL, POSICION_PALA; POSICION NUEVA DESPUES DE HABER TENIDO EN 
	  PUSH BX               ; CUENTA EL MOVIMIENTO EFECTUADO POR LA PALA
	  MOV  BL, 21
	  PUSH BX
	  CALL MENSAJE         
	  MOV  AL, -1           ; SI SE LLEGA ES PORQUE SE HA PULSADO 'O' 
				; O 'P' SE MUEVE A 'AL' -1 PARA EL BUCLE DE
				; ENCUESTA DE LA SUBRUTINA LEETEC_I 
FIN_WHILE:JMP  FIN                      
 FIN_LEC:MOV  AL, -1            ; SI SE TRATA DE UN BREAK MOVEMOS AL 'AL' -1
				; PARA QUE SE VUELVA A UN BUCLE DE ENCUESTA
				; QUE SE ENCUENTRA EN LA SUBRUTINA LEETEC_I
				
     FIN:MOV  CL, AL            ; SALVAMOS EN 'CL' EL CONTENIDO DE 'AL' QUE 
				; ES LO QUE UTILIZA LA SUBRUTINA LEETEC_I
  
	 IN   AL, 61H
	 OR   AL, 80H
	 OUT  61H, AL           ; SECUENCIA DE STROBE
	 AND  AL, 7FH
	 OUT  61H, AL
	 
	 MOV  AL, 20H           ; EOI
	 OUT  20H, AL
	 
	 MOV  AL, CL            ; VOLVEMOS A PASAR A 'AL' EL VALOR QUE ANTES
				; HAVIAMOS ALMACENADO EN 'CL' PARA REALIZAR 
				; EL RETORNO
	 POP  BX
	 POP  DS                ; REESTABLECER ESTADO 
	 POP  CX
	 STI                    ; DESHINIBIMOS LAS INTERUPCIONES
	 
	 IRET                   ; RETORNO DE LA SUBRUTINA DE ATENCION

	 LEECAR_I  ENDP
	   CODIGO ENDS
		   END
 
