 TITLE LEETEC_I

;    PROCEDIMIENTO QUE GESTIONA LAS INTERRUPCIONES DE TECLADO
     
     
      EXTRN DIRPANT: FAR
      EXTRN LEECAR_I: FAR
      EXTRN TEC_IP:  WORD              ; SUBRUTINAS Y VARIABLES EXTERNAS 
      EXTRN TEC_CS:  WORD              ; UTILIZADAS 
      EXTRN DIRPAN: WORD

    CODIGO SEGMENT PARA PUBLIC 'CODIGO'
        ASSUME CS:CODIGO

    PUBLIC LEETEC_I

  LEETEC_I PROC FAR
          
          PUSH BP                      ; ENLACE DINAMICO
          MOV  BP, SP
          
          PUSH AX                      ; SALVAR ESTADO
          PUSH BX
          
          CLI                          ; INHIBICION DE LAS INTERUPCIONES      
          
          MOV  BX, 36                  ; DIRECCION EN EL V.I DE LA SUBRUTINA
                                       ; DE ATENCION DEL TECLADO 
          MOV  AX, 0
          MOV  ES, AX                  ; DIRECCION BASE DEL V.I
          MOV  AX, ES:[BX]             
          MOV  TEC_IP, AX              ; ALMACENAMOS EL 'IP' DE LA SUBRUTINA
                                       ; DE ATENCION DEL SISTEMA  
          MOV  AX, ES:[BX+2]
          MOV  TEC_CS, AX              ; ALMACENAMOS EL 'CS' DE LA SUBRUTINA
                                       ; DE ATENCION DEL SISTEMA  
          MOV  AX, OFFSET LEECAR_I
          MOV  ES:[BX], AX             ; ESTABLECEMOS EL 'IP' DE NUESTRA 
                                       ; PROPIA SUBRUTINA DE ATENCION  
          MOV  AX, SEG LEECAR_I
          MOV  ES:[BX+2], AX           ; ESTABLECEMOS EL  'CS' DE NUESTRA
                                       ; PROPIA SUBRUTINA DE ATENCION 
          
          STI                          ; DESINHIBIMOS LAS INTERUPCIONES
         
          CALL DIRPANT                 ; VOLVEMOS A ESTABLECER EN 'ES' LA 
          MOV  ES, DIRPAN              ; DIRECCION DE COMIENZO DE LA PANTALLA
          
          MOV  AL, -1                   
   ENCU_F:CMP  AL, -1                   ; BUCLE QUE ESPERA A QUE SE PULSE LA
          JE   P_ENCU_F                 ; TECLA 'F' PARA ACABAR  
          CMP  AL, 46h
          JE   FIN_ENCU
 P_ENCU_F:JMP  ENCU_F
 FIN_ENCU:CLI                          ; INHIBIR LAS INTERUPCIONES, PARA 
                                       ; REESTABLECER EL 'IP' Y 'CS' 
          XOR  AX, AX
          MOV  ES, AX                  ; MOVEMOS A 'ES' LA DIRECCION BASE DEL
                                       ; VECTOR DE INTERUPCIONES
          MOV  BX, 36
          MOV  AX, TEC_IP
          MOV  ES:[BX], AX             ; REESTABLECEMOS EL 'IP' DE LA 
                                       ; SUBRUTINA DE ATENCION DEL SISTEMA
          MOV  AX, TEC_CS
          MOV  ES:[BX+2], AX           ; REESTABLECEMOS EL 'CS' DE LA
                                       ; SUBRUTINA DE ATENCION DEL SISTEMA
 
          STI                          ; DESINHIBIMOS LAS INTERUPCIONES
          
	  CALL DIRPANT
          MOV  ES, DIRPAN              ; VOLVEMOS A ESTABLECER EN 'ES' LA 
                                       ; DIRECCION DE COMIENZO DE LA PANTALLA
          POP  BX
          POP  AX                      ; RESTAURAR ESTADO
          POP  BP
          
          RET                          ; DEVOLVER EL CONTROL 
          
          LEETEC_I ENDP
            CODIGO ENDS
          
                   END
