 TITLE PARED

; PROCEDIMIENTO QUE CONTROLA SI LA PELOTA PEGA EN ALGUNA PARED O NO

        EXTRN ESCR_CAR: FAR    
        EXTRN CAR_MEM: FAR
        EXTRN BIP: FAR
        EXTRN MOVI: BYTE
        EXTRN FILA_AUX: WORD
        EXTRN COL_AUX: WORD
        EXTRN FILA_P: WORD
        EXTRN COLUMNA_P: WORD
        EXTRN MOV_HORIZ: WORD
        EXTRN MOV_VERT: WORD
        EXTRN MENSAJE: FAR
        EXTRN LAD_BLANCOS: BYTE          
        EXTRN ACT_PTOS: FAR 
                 
        CODIGO SEGMENT PARA PUBLIC 'CODIGO'
                ASSUME CS:CODIGO

        PUBLIC PARED

        PARED PROC FAR

                PUSH BP                 ;ENLACE DINAMICO
                MOV  BP, SP

                PUSH AX                 ; SALVAMOS EL ESTADO
                PUSH CX
                PUSH BX
                CMP  MOVI, 1
                JE   FIN1                         

                SUB  SP, 2              ; RESERVAMOS UN ESPACIO EN LA PILA
                MOV  AX, FILA_AUX
                PUSH AX
                MOV  AX, COL_AUX
                PUSH AX
                CALL CAR_MEM
                
                POP  AX                 ; GUARDAMOS EN 'AX' EL CARACTER DE 
                                        ; MEMORIA EN ESA POSICION
                                                        
                CMP  AL, 0BBh
                JE   ESQUINA_1
                CMP  AL, 0C9h
                JE   ESQUINA_1
                CMP  AL, 0CCh
                JE   ESQUINA_1
                CMP  AL, 0B9h
                JE   ESQUINA_1             
                CMP  AL, 186
                JE   LATERAL
                CMP  AL, 205
                JE   ARRIBA_1
                JMP  FIN
                
     LATERAL:   CMP  FILA_AUX, 21
                JNE  AUX_LAT 
                MOV  AX, MOV_HORIZ
                MOV  CX, -1
                MUL  CX
                MOV  MOV_HORIZ, AX
                MOV  AX, MOV_VERT
                MOV  CX, -1
                MUL  CX
                MOV  MOV_VERT, AX
                JMP  ACTUALIZAR
       FIN1:    JMP  FIN
     ESQUINA_1: JMP  ESQUINA_2
       AUX_LAT: CMP  FILA_AUX, 8
                JE   LAT_CON
                CMP  FILA_AUX, 6
                JE   LAT_CON
                CMP  FILA_AUX, 4
                JE   LAT_CON
                CMP  FILA_AUX, 2
                JE   LAT_CON
                MOV  AX, MOV_HORIZ
                MOV  CX, -1
                MUL  CX
                MOV  MOV_HORIZ, AX    
                JMP  ACTUALIZAR

     LAT_CON:   SUB  SP, 2
                MOV  AX, FILA_AUX
                PUSH AX
                MOV  AX, COLUMNA_P
                PUSH AX
                CALL CAR_MEM
                POP  AX
                CMP  AL, 0B2H
                JE   LAT_LAD
                CMP  AL, 0DBH
                JE   LAT_LAD
                MOV  AX, MOV_HORIZ
                MOV  CX, -1
                MUL  CX
                MOV  MOV_HORIZ, AX
                JMP  ACTUALIZAR
     ARRIBA_1:  JMP  ARRIBA
     ESQUINA_2: JMP  ESQUINA_3           
       LAT_LAD: CMP  COLUMNA_P, 1
                JE   IZQ
                MOV  AX, 8
                PUSH AX
                MOV  AX, OFFSET LAD_BLANCOS
                PUSH AX
                MOV  AX, COLUMNA_P
                SUB  AX, 7
                PUSH AX
                MOV  AX, FILA_AUX
                PUSH AX
                CALL MENSAJE

                MOV  AX, 8
                PUSH AX
                MOV  AX, OFFSET LAD_BLANCOS
                PUSH AX
                MOV  AX, COLUMNA_P
                SUB  AX, 7
                PUSH AX
                MOV  AX, FILA_AUX
                DEC  AX
                PUSH AX
                CALL MENSAJE
                
                
                JMP  FIN_LAT_LAD
         IZQ:   MOV  AX, 8
                PUSH AX
                MOV  AX, OFFSET LAD_BLANCOS
                PUSH AX
                MOV  AX, COLUMNA_P
                PUSH AX
                MOV  AX, FILA_AUX
                PUSH AX
                CALL MENSAJE
                MOV  AX, 8
                PUSH AX
                MOV  AX, OFFSET LAD_BLANCOS
                PUSH AX
                MOV  AX, COLUMNA_P
                PUSH AX
                MOV  AX, FILA_AUX
                DEC  AX
                PUSH AX
                CALL MENSAJE
                MOV  AX, FILA_AUX
                PUSH AX
                CALL ACT_PTOS

    FIN_LAT_LAD:MOV  AX, MOV_VERT
                MOV  CX, -1
                MUL  CX
                MOV  MOV_VERT, AX
                MOV  AX, MOV_HORIZ
                MOV  CX, -1
                MUL  CX
                MOV  MOV_HORIZ, AX
                JMP  ACTUALIZAR              
     ESQUINA_3: JMP  ESQUINA     
 
      ARRIBA:   CMP  FILA_AUX, 0
                JE   ARRIBA_P
                MOV  AX, MOV_VERT
                MOV  CX, -1
                MUL  CX
                MOV  MOV_VERT, AX
                JMP  ACTUALIZAR
      ARRIBA_P: SUB  SP, 2
                MOV  AX,FILA_AUX
                INC  AX
                PUSH AX
                MOV  AX, COL_AUX
                PUSH AX
                CALL CAR_MEM
                POP  AX
                CMP  AL,0B2H
                JE   ARRIBA_L
                CMP  AL,0DBH
                JE   ARRIBA_L
                   
 
   ARRIBA_FIN:  MOV  AX, MOV_VERT
                MOV  CX, -1
                MUL  CX
                MOV  MOV_VERT, AX  
                JMP  ACTUALIZAR
     ARRIBA_L:  MOV  AX, 8
                PUSH AX
                MOV  AX, OFFSET LAD_BLANCOS
                PUSH AX
                MOV  AX, COL_AUX
                TEST AX, 01H
                JZ   PAR
                PUSH AX
                JMP  CONTINUAR
           PAR: SUB  AX, 7
                PUSH AX
     CONTINUAR: MOV  AX, 1
                PUSH AX
                CALL MENSAJE
                MOV  AX, 8
                PUSH AX
                MOV  AX, OFFSET LAD_BLANCOS
                PUSH AX
                MOV  AX, COL_AUX
                TEST AX, 01H
                JZ   PAR_1
                PUSH AX
                JMP  CONTINUAR_1
         PAR_1: SUB  AX, 7
                PUSH AX
   CONTINUAR_1: MOV  AX, 2
                PUSH AX
                CALL MENSAJE
                MOV  AX, 2
                PUSH AX
                CALL ACT_PTOS
                
                MOV  AX, MOV_VERT
                MOV  CX, -1
                MUL  CX
                MOV  MOV_VERT, AX
                MOV  AX, MOV_HORIZ
                MOV  CX,-1
                MUL  CX
                MOV  MOV_HORIZ, AX  
                JMP  ACTUALIZAR  

     ESQUINA:   MOV  AX, MOV_VERT
                MOV  CX, -1
                MUL  CX
                MOV  MOV_VERT, AX
                MOV  AX, MOV_HORIZ
                MOV  CX, -1
                MUL  CX
                MOV  MOV_HORIZ, AX
                JMP  ACTUALIZAR        

   ACTUALIZAR:  MOV  AX, 07h            ; BORRAMOS LA PELOTA
                PUSH AX
                MOV  AX, ' '
                PUSH AX
                MOV  AX, COLUMNA_P
                PUSH AX
                MOV  AX, FILA_P
                PUSH AX
                CALL ESCR_CAR

                MOV  AX, 07h
                PUSH AX                 ; ESCRIBIMOS LA PELOTA EN SU NUEVA
                MOV  AX, 'o'            ; POSICION EN LA PANTALLA
                PUSH AX
                MOV  AX, COLUMNA_P
                ADD  AX, MOV_HORIZ
                MOV  COLUMNA_P, AX
                MOV  AX, COLUMNA_P 
                PUSH AX
                MOV  AX, FILA_P
                ADD  AX, MOV_VERT
                MOV  FILA_P, AX
                MOV  AX, FILA_P
                PUSH AX
                CALL ESCR_CAR
                  
                CALL BIP

                MOV  MOVI, 1

         FIN:   POP  BX
                POP  CX                 ; RESTAURAMOS EL ESTADO
                POP  AX
                POP  BP
         
                RET                     ; DEVOLVEMOS EL CONTROL

          PARED ENDP
         CODIGO ENDS

                END
