; Fichero: HORAPAN.ASM
; Rutina que escribe el marcador del tiempo en la pantalla.

TITLE  HORAPAN

; Rutinas FAR que utiliza HORAPAN:  
EXTRN ESCR_CAR:FAR        ;Rutina que escribe un carcter por pantalla.

; Parmetros que utiliza HORAPAN:
MINUTO  EQU [BP+6]
SEGUNDO EQU [BP+8]

CODIGO SEGMENT PUBLIC 'CODIGO'
       ASSUME CS:CODIGO

PUBLIC  HORAPAN
HORAPAN PROC FAR

       PUSH BP
       MOV  BP,SP         ;Enlace dinmico.
       PUSH AX            ;Salvar registro.

       MOV  AX,0AH
       PUSH AX            ;Empilar atributo.
       MOV  AX,MINUTO
       MOV  AL,AH         ;Para empilar MINUTO2 (parte alta).
       PUSH AX            ;Empilar caracter.
       MOV  AX,69
       PUSH AX            ;Empilar columna.
       MOV  AX,23
       PUSH AX            ;Empilar fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.

       MOV  AX,0AH
       PUSH AX            ;Empilar atributo.
       MOV  AX,MINUTO
       PUSH AX            ;La rutina slo toma la parte baja, MINUTO1.
       MOV  AX,70
       PUSH AX            ;Empilar columna.
       MOV  AX,23
       PUSH AX            ;Empilar fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.

       MOV  AX,0AH
       PUSH AX            ;Empilar atributo.
       MOV  AX,SEGUNDO
       MOV  AL,AH         ;Para empilar SEGUNDO2 (parte alta).
       PUSH AX            ;Empilar caracter.
       MOV  AX,72
       PUSH AX            ;Empilar columna.
       MOV  AX,23
       PUSH AX            ;Empilar fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.

       MOV  AX,0AH
       PUSH AX            ;Empilar atributo.
       MOV  AX,SEGUNDO
       PUSH AX            ;La rutina slo toma la parte baja, SEGUNDO1.
       MOV  AX,73
       PUSH AX            ;Empilar columna.
       MOV  AX,23
       PUSH AX            ;Empilar fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.

       POP  AX           ;Restaurar registros.
       POP  BP           ;Restaurar enlace dinmico.
       RET  4            ;Retorna al programa llamador eliminando
                         ;parmetros.

HORAPAN  ENDP
CODIGO   ENDS
         END
