; Fichero: LEECAR_E.ASM
; Rutina que lee del teclado por encuesta.

TITLE LECAR_E

CODIGO SEGMENT PUBLIC 'CODIGO'
       ASSUME CS:CODIGO

PUBLIC   LEECAR_E
LEECAR_E PROC FAR

      PUSH BP
      MOV BP,SP           ;Se establece el enlace dinmico.
      PUSH DX             ;Guardar registros.

      MOV  DX,060H        ;Leer cdigo de rastreo del registro de datos
      IN   AL,DX          ;del teclado.
      MOV  DL,AL          ;En DX el cdigo de rastreo.

      IN   AL,61H         ;Comienzo de la secuencia de STROBE.
      OR   AL,80H
      OUT  61H,AL
      AND  AL,7FH
      OUT  61H,AL         ;Fin de la secuencia de STROBE.

      TEST DL,80H
      JZ   MAKE
      MOV  AL,-1          ;Si es un break...
      JMP  FIN            ;... devuelve en AX un -1.

MAKE: MOV  AL,DL          ;AX:=cdigo de rastreo (en caso de MAKE).

FIN:  POP  DX             ;Restaurar registros.
      POP  BP             ;Restaurar enlace dinmico.
      RET

LEECAR_E  ENDP
CODIGO    ENDS
          END
