 TITLE Teclado por INTERRUPCIONES (mientras escribe '#')

 PILA SEGMENT PARA STACK 'STACK'
      DB 64 DUP ('      ')
 PILA ENDS

 DATOS SEGMENT PARA PUBLIC 'DATA'
      DIRPAN  DW ?
      KEYB_IP DW 0
      KEYB_CS DW 0
      FILA    DW 16
      COL     DW 0

      TABLA   DB 27,'1234567890?'
              DB 8,9,'QWERTYUIOP[]',13,'*'
              DB 'ASDFGHJKL$;$','*'
              DB '<ZXCVBNM,.-','*'
              DB ' *'
              DB ' ',13 DUP ('*')
              DB '+98-456+1230,'
 DATOS ENDS


 CODIGO SEGMENT PARA PUBLIC 'CODE'
     ASSUME CS:CODIGO, SS:PILA, DS:DATOS


 PRINCIPAL PROC FAR ;

           push DS
           sub  AX,AX
           push AX

           mov  AX,DATOS      ; actualizacin de DS
           mov  DS,AX

           call DIR_PAN
           mov  ES,DIRPAN     ; Detecta @pantalla modo texto 80c
           call CLRSCR        ; Limpia Pantalla
           call CHG_VECTOR    ; cambia la @ de la int de teclado

           mov  BX, 0         ; bucle que escribe '#'
           mov  CX, 1280
           mov  AL, '#'
 OTROMAS:  mov  AH, 07h
           mov  ES:[BX], AX
           add  BX, 2
           call RETARDO
           loop OTROMAS       ; dec CX  si  CX<>0 -> SALTA a OTROMAS

           call RST_VECTOR    ; restaura la @ de la int de teclado
           call CLRSCR

           ret

 PRINCIPAL ENDP
;



 CHG_VECTOR PROC NEAR ;

            CLI
            push ES
            push BX
            push AX
            mov  AX, 0
            mov  ES, AX
            mov  BX, 9*4
            mov  AX, ES:[BX]
            mov  KEYB_IP, AX
            mov  AX, ES:2[BX]
            mov  KEYB_CS, AX
            mov  AX, offset NEWKINT
            mov  ES:[BX], AX
            mov  AX, seg NEWKINT
            mov  ES:2[BX], AX
            pop  AX
            pop  BX
            pop  ES
            STI
            ret
 CHG_VECTOR ENDP

 RST_VECTOR PROC NEAR ;

            CLI
            push  ES
            push  BX
            push  AX
            mov   AX, 0
            mov   ES, AX
            mov   BX, 9*4
            mov   AX, KEYB_IP
            mov   ES:[BX], AX
            mov   AX, KEYB_CS
            mov   ES:2[BX], AX
            pop   AX
            pop   BX
            pop   ES
            STI
            ret
 RST_VECTOR ENDP

 CLRSCR PROC NEAR ;

        push  BX
        push  ES
        mov   ES, DIRPAN
        mov   BX, 0
 BUCLE: mov   ES:[BX], 0700h
        add   BX, 2
        cmp   BX, 4000
        jl    BUCLE
        pop   ES
        pop   BX
        ret

 CLRSCR ENDP

 WRITECHAR PROC NEAR ;

 ; Escribe carcter en memoria video.  ( Attr|Char, columna, fila : WORD);

           push BP
           mov  BP, SP
           push AX
           push BX
           push CX
           push DX
           mov  AX, 4[BP]     ;AX < fila
           mov  CX, 80
           mul  CX            ;AX <    fila * 80
           add  AX, 6[BP]     ;AX <   (fila * 80) + col
           shl  AX, 1         ;AX < 2*(fila * 80) + col
           mov  BX, AX        ;BX < @pantalla
           mov  AX, 8[BP]     ;AX < attr | char
           mov  ES:[BX], AX   ;write attr | char
           pop  DX
           pop  CX
           pop  BX
           pop  AX
           mov  SP,BP
           pop  BP
           ret  6

 WRITECHAR ENDP

 DIR_PAN PROC NEAR ;

         push  AX
         push  ES
         xor   AX, AX
         mov   ES, AX
         mov   AL, ES:[449h]
         cmp   AL, 7
         je    BCERO
         cmp   AL, 2
         je    BOCHO
         cmp   AL, 3
         je    BOCHO
         jmp   ERROR
 BCERO:  mov   DIRPAN, 0B000h
         jmp   FINAL
 BOCHO:  mov   DIRPAN, 0B800h
         jmp   FINAL
 ERROR:  mov   DIRPAN, 0h
 FINAL:  pop   ES
         pop   AX
         ret

 DIR_PAN endp
;







 RETARDO PROC NEAR ;

         push CX
         mov  CX, 48000
 REPEAT: nop
         loop REPEAT
         pop  CX
         ret

 RETARDO ENDP

 NEWKINT PROC NEAR ;

         push AX
         push BX

         in   AL, 60h
         test AL, 80h
         jnz  STROBE

         cmp  AL, 14       ; comienzo del aadido (BORRAR)
         je   BORRAR
         cmp  AL, 28
         je   INTRO
         jmp  CARACT

 BORRAR: dec  word ptr COL
         mov  AL, ' '
         mov  AH, 07h
         push AX
         mov  AX, COL
         push AX
         mov  AX, FILA
         push AX
         call WRITECHAR
         jmp  EOI          ; fin del aadido (BORRAR)  

 INTRO:  xor  AX, AX
         mov  word ptr COL, AX
         inc  word ptr FILA
         jmp  EOI

 CARACT: mov  BX, offset TABLA
         dec  AL
         XLAT                   ; AL:=[BX+AL]

         mov  AH, 07h
         push AX
         mov  AX, COL
         push AX
         mov  AX, FILA
         push AX
         call WRITECHAR

         inc  word ptr COL
         cmp  word ptr COL, 80
         jne  STROBE
         mov  word ptr COL, 0
         inc  word ptr FILA

 STROBE: in   AL, 61h
         or   AL, 80h
         out  61h, AL
         and  AL, 7Fh
         out  61h, AL

 EOI:    mov  AL, 20h      ; Siempre al acabar una int (EOI)
         out  20h, AL

         pop  BX
         pop  AX
         IRET

 NEWKINT ENDP
;

 CODIGO ENDS

     END PRINCIPAL
