CODIGO2 SEGMENT PARA PUBLIC 'CODE'
    ASSUME CS:CODIGO2

PUBLIC MENOR

MENOR PROC FAR

        PUSH BP         ;enlace dinamico
        MOV BP,SP
        PUSH AX         ;salvar registros
        PUSH BX
        PUSH CX
        PUSH DX
        PUSH SI
        PUSH DI
        MOV  AX,6[BP]   ;AX = parametro numero de componentes
        MOV  BX,8[BP]   ;BX = parametro direccion del vector
                        ;se pone 8 porque al ser subrutina separada
                        ;en otro fichero se empila el CS y el IP luego 
                        ;son dos parametros en vez de uno.
        MOV  CX,[BX]    ;CX = primer componente
        MOV  SI,BX
        ADD  SI,2       ;SI = direccion del siguiente componente
        DEC  AX         ;un componente menos
        MOV  DX,0       ;DX = numero de componente comparados o tratados
BUCLE2: MOV  DI,[SI]    ;DI = siguiente componente
        CMP  DI,CX      ;comparando componentes
        JGE  SEGUIR     ;si el primero es menor no hace falta cambiar(SEGUIR)
        MOV  [BX],DI    ;cambiar componentes
        MOV  [SI],CX
        MOV  CX,DI      ;CX = el menor componente hasta ahora
SEGUIR: ADD  SI,2       ;SI = direccion del siguiente componente
        ADD  DX,1       ;control del bucle
        CMP  DX,AX
        JNE  BUCLE2
        POP  DI         ;restaurar registros
        POP  SI
        POP  DX
        POP  CX
        POP  BX
        POP  AX
        POP  BP         ;enlace dinamico
        RET  4          ;retornar eliminando 2 parametros (4 bytes)
MENOR ENDP

                
CODIGO2  ENDS                                                        
        END

