TITLE  ORDENAR

PILA  SEGMENT PARA STACK 'STACK'
      DB 64 DUP ('PILA  ')
PILA ENDS

DATOS  SEGMENT  PARA PUBLIC 'DATA'
VECTOR DW 7,3,-1,5,0
NUME   DW 5
DATOS ENDS

CODIGO SEGMENT PARA PUBLIC 'CODE'
      ASSUME CS:CODIGO ,DS:DATOS, SS:PILA

PRINCIPAL PROC FAR

        PUSH DS         ;para volver al DOS
        SUB AX,AX       
        PUSH AX         
        
        MOV AX,DATOS    ;inicializar DS
        MOV DS,AX
        
        LEA  AX,VECTOR  ;AX = direccion del vector
        MOV  CX,NUME    ;CX = numero de componentes
BUCLE:  PUSH AX         ;parametros
        PUSH CX
        CALL MENOR      ;deja el componente mas pequeo en la primera posicion
        ADD  AX,2       ;actualizar la direccion
        SUB  CX,1       ;actualizar el numero de componentes
        CMP  CX,1       ;hemos acabado?
        JNE  BUCLE      
        RET         
PRINCIPAL ENDP
MENOR PROC NEAR

        PUSH BP         ;enlace dinamico
        MOV BP,SP
        PUSH AX         ;salvar registros
        PUSH BX
        PUSH CX
        PUSH DX
        PUSH SI
        PUSH DI
        MOV  AX,4[BP]   ;AX = parametro numero de componentes
        MOV  BX,6[BP]   ;BX = parametro direccion del vector
        MOV  CX,[BX]    ;CX = primer componente
        MOV  SI,BX
        ADD  SI,2       ;SI = direccion del siguiente componente
        DEC  AX         ;un componente menos
        MOV  DX,0       ;DX = numero de componente comparados o tratados
BUCLE2: MOV  DI,[SI]    ;DI = siguiente componente
        CMP  DI,CX      ;comparando componentes
        JGE  SEGUIR     ;si el primero es menor no hace falta cambiar(SEGUIR)
        MOV  [BX],DI    ;cambiar componentes
        MOV  [SI],CX
        MOV  CX,DI      ;CX = el menor componente hasta ahora
SEGUIR: ADD  SI,2       ;SI = direccion del siguiente componente
        ADD  DX,1       ;control del bucle
        CMP  DX,AX
        JNE  BUCLE2
        POP  DI         ;restaurar registros
        POP  SI
        POP  DX
        POP  CX
        POP  BX
        POP  AX
        POP  BP         ;enlace dinamico
        RET  4          ;retornar eliminando 2 parametros (4 bytes)
MENOR ENDP

                
CODIGO   ENDS                                                        
        END PRINCIPAL

