
{Este programa pertenece al ensamblador Txori-Bird}

 .TITLE PCAP3

    PILA: .WORD 20;
    NUM1: .VALUE 15651;
    NUM2: .WORD 1;

 .PROC MAIN

            MOVA SP,PILA      {Pone en SP la direccion de la pila}
            LD   R8,NUM1      {r8 <- num}
            BGT  R8,BUCLE     {Si r8 < 0 => r8 <- r8 * -1}
            MULI R8,R8,#-1
    
     BUCLE: ADDI R8,R8,#1
            ADDI SP,SP,#6     {Adelanta 6 posiciones en la pila}
                              {5 para los parmetros que devuelva PONREG}
                              {1 para el parmetro que devuelva SICAP}

            PUSH R8           {Pasa el nmero a la pila}
            CALL PONREG       {Funcin que coloca cada digito en registros}
                              {Devuelve 5 registros uno con cada dgito}
            SUBI SP,SP,#1     {Quita de la pila el registro que se le paso}

            CALL SICAP        {Funcion que comprueba si es capicua}
                              {Devuelve 0 (No) o 1 (Si)}
            SUBI SP,SP,#5     {Quita de la pila la salidade PONREG que es}
                              {a la vez entrada de SICAP} 
            POP R6
            BEQ R6,BUCLE      {Vuelve al bucle si no es capicua}

            ST R8,NUM2        {Devuelve siguiente nmero capicua}
            retm

 .ENDP MAIN

 .PROC SICAP

            LDD R5,-1[SP]     {Lee de la pila los registros a procesar}
            LDD R4,-2[SP]
            LDD R3,-3[SP]
            LDD R2,-4[SP]
            LDD R1,-5[SP]

            ADD R6,R1,R2
            ADD R7,R6,R3      {r7 <- x1 + x2 + x3}

            SUBI R9,R8,#10    {Si N es cero o de un digito => capicua}
            BLE  R9,SI
         
            BEQ R7,DIG2       {Si 0 < N =< 99 => DIG2}

            BEQ R6,DIG3       {Si 100 =< N =< 999 => DIG3}

            BEQ R1,DIG4       {Si 1000 =< N =< 9999 => DIG4}

      DIG5: SUB R6,R1,R5      {Capicua ssi r1-r5 = r2-r4 = 0} 
            BNE R6,NO
            SUB R6,R2,R4
            BNE R6,NO
            JMP SI

      DIG4: SUB R6,R2,R5      {Capicua ssi r2-r5 = r3-r4 = 0}
            BNE R6,NO
            SUB R6,R3,R4
            BNE R6,NO
            JMP SI

      DIG3: SUB R6,R3,R5      {Capicua ssi r3-r5 = 0}
            BEQ R6,SI
            JMP NO

      DIG2: SUB R6,R4,R5      {Capicua ssi r4-r5 = 0}
            BEQ R6,SI
            JMP NO

        SI: MOVI R6,#1        {Si capicua (1)}
            JMP FIN

        NO: MOVI R6,#0        {No capicua (0)} 

       FIN: STD R6,-6[SP]     {Deja en la pila la salida de la funcin}
            RET

 .ENDP

 .PROC PONREG

            LDD R8,-1[SP]     {Lee de la pila el nmero a procesar}

            DIVI R1,R8,#10000 {r1 <- x1}

            DIVI R2,R8,#1000  {r2 <- x1 x2}
            MULI R3,R1,#10000 {r3 <- x1 0 0 0 0}
            MULI R5,R2,#1000  {r5 <- x1 x2 0 0 0}
            SUB  R2,R5,R3     {r2 <- 0 x2 0 0 0}
            DIVI R2,R2,#1000  {r2 <- x2}

            DIVI R3,R8,#100   {r3 <- x1 x2 x3}
            MULI R4,R3,#100   {r4 <- x1 x2 x3 0 0}
            SUB  R3,R4,R5     {r3 <- 0 0 x3 0 0}
            DIVI R3,R3,#100   {r3 <- x3}

            DIVI R5,R8,#10    {r5 <- x1 x2 x3 x4}
            MULI R6,R5,#10    {r6 <- x1 x2 x3 x4 0}
            SUB  R7,R6,R4     {r7 <- 0 0 0 x4 0}
            DIVI R4,R7,#10    {r4 <- x4}

            SUB  R5,R8,R6     {r5 <- x5}

            STD R5,-2[SP]     {Deja en la pila la salida de la funcin}
            STD R4,-3[SP]
            STD R3,-4[SP]
            STD R2,-5[SP]
            STD R1,-6[SP]

            RET
  .ENDP
  .END    
